SystemOrganization addCategory: #'MareaTests-Mocks'!
SystemOrganization addCategory: #'MareaTests-Swapping'!

TestCase subclass: #MARBaseObjectGraphSwapperTest
	instanceVariableNames: 'classFactory classProxyClass regularObjectProxyClass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MareaTests-Swapping'!

!MARBaseObjectGraphSwapperTest class methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 1/5/2012 11:32'!
isAbstract
	^ self = MARBaseObjectGraphSwapperTest ! !

!MARBaseObjectGraphSwapperTest methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 11/30/2011 14:20'!
classFactory
	^classFactory! !

!MARBaseObjectGraphSwapperTest methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 12/13/2011 16:23'!
classProxyClass
	^ classProxyClass  ! !

!MARBaseObjectGraphSwapperTest methodsFor: 'helpers' stamp: 'MarianoMartinezPeck 11/30/2011 14:20'!
newClassOrTrait
	"Returns a class for testing"

	^ self newClassWithInstanceVariableNames: ''! !

!MARBaseObjectGraphSwapperTest methodsFor: 'helpers' stamp: 'MarianoMartinezPeck 12/9/2011 16:16'!
newClassOrTraitSubclassOf: aClass
	"Returns a class for testing"

	^ self newClassWithInstanceVariableNames: '' superclass: aClass! !

!MARBaseObjectGraphSwapperTest methodsFor: 'helpers' stamp: 'MarianoMartinezPeck 12/14/2011 15:59'!
newClassOrTraitWithSuperClass: superclass
	"Returns a class for testing"

	^ self newClassWithInstanceVariableNames: '' superclass: superclass! !

!MARBaseObjectGraphSwapperTest methodsFor: 'helpers' stamp: 'MarianoMartinezPeck 12/9/2011 16:17'!
newClassWithInstanceVariableNames: instanceVariableNames
	^ self newClassWithInstanceVariableNames: instanceVariableNames superclass: Object! !

!MARBaseObjectGraphSwapperTest methodsFor: 'helpers' stamp: 'MarianoMartinezPeck 12/9/2011 16:16'!
newClassWithInstanceVariableNames: instanceVariableNames superclass: aSuperclass
	"Returns a class for testing, with the specified instance variables."
	
	"| m c metaformat format postFix |

	metaformat := ClassBuilder new
	    computeFormat: #normal instSize: 0
	    forSuper: Object class ccIndex: 0.
	
	format := ClassBuilder new
	    computeFormat: #normal instSize: instanceVariableNames size
	    forSuper: Object ccIndex: 0.

	m := Metaclass new.
	m superclass: Object class.
	m methodDict: MethodDictionary new.
	m setFormat: metaformat.

	c := m new.
	c superclass: Object.
	c methodDict: MethodDictionary new.
	c setFormat: format.

	c setInstVarNames: instanceVariableNames.
	postFix := (DateAndTime now asSeconds) printString.
	c setName: (#ClassForTestToBeDeleted, postFix) asSymbol.
	Smalltalk at: c name put: c."
	
	^ self classFactory
		newSubclassOf: aSuperclass
		instanceVariableNames: instanceVariableNames
		classVariableNames: ''! !

!MARBaseObjectGraphSwapperTest methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 12/20/2011 14:26'!
regularObjectProxyClass
	^ regularObjectProxyClass ! !

!MARBaseObjectGraphSwapperTest methodsFor: 'setUp - tearDown' stamp: 'MarianoMartinezPeck 2/6/2012 19:09'!
setUp

	super setUp.
	
	MARObjectGraphSwapper resetAll. 
	MARObjectGraphExporter reset.
	MARObjectGraphExporter proxyCreator: MARProxyCreator.
	
	regularObjectProxyClass := MARRegularObjectProxy.
	classProxyClass := MARClassProxy.
	
	"For mocks you should also change #swapIn:  and  enable the following: "	
	"MARObjectGraphExporter proxyCreator: MARMockProxyCreator.
	regularObjectProxyClass := MARRegularObjectProxyMock.
	classProxyClass := MARClassProxyMock.
	"		

	self setUpClassFactory.
	MARLogger changeToFileLogger.
	! !

!MARBaseObjectGraphSwapperTest methodsFor: 'setUp - tearDown' stamp: 'MarianoMartinezPeck 11/30/2011 14:20'!
setUpClassFactory
	classFactory := ClassFactoryForTestCase new! !

!MARBaseObjectGraphSwapperTest methodsFor: 'helpers' stamp: 'MarianoMartinezPeck 12/20/2011 14:41'!
swapIn: anObject	
	anObject name.
"	When using MOCKS, comment the first line and put this one:"
	"MARObjectGraphImporter new swapInGraphFor: anObject."! !

!MARBaseObjectGraphSwapperTest methodsFor: 'helpers' stamp: 'MarianoMartinezPeck 12/17/2011 01:34'!
swapOut: anObject
		MARObjectGraphExporter new swapOutGraph: anObject.
! !

!MARBaseObjectGraphSwapperTest methodsFor: 'helpers' stamp: 'MarianoMartinezPeck 12/19/2011 16:07'!
swapOutAndClean: anObject
	MARObjectGraphExporter new swapOutGraph: anObject.
	MARObjectGraphExporter reset.! !

!MARBaseObjectGraphSwapperTest methodsFor: 'helpers' stamp: 'MarianoMartinezPeck 12/17/2011 01:34'!
swapOutClass: aClass
		MARObjectGraphExporter new swapOutClass: aClass.
! !

!MARBaseObjectGraphSwapperTest methodsFor: 'helpers' stamp: 'MarianoMartinezPeck 1/2/2012 10:32'!
swapOutClassWithInstances: aClass
		MARObjectGraphExporter new swapOutClassWithInstances: aClass.
! !

!MARBaseObjectGraphSwapperTest methodsFor: 'setUp - tearDown' stamp: 'MarianoMartinezPeck 2/5/2012 20:29'!
tearDown
	MARBaseObjectGraphSwapperTest compileAll.
	self classFactory cleanUp.
	MARObjectGraphExporter reset.
	3 timesRepeat: [Smalltalk garbageCollect].
	self regularObjectProxyClass mareaUninstallIfNeededAllInstances.
	self classProxyClass mareaUninstallIfNeededAllInstances.! !

MARBaseObjectGraphSwapperTest subclass: #MARClassSwappingTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MareaTests-Swapping'!

!MARClassSwappingTest methodsFor: 'tests class swapping' stamp: 'MarianoMartinezPeck 1/5/2012 11:28'!
testClassAndMetaclassAreGarbageCollected

	| aClass metaclassesSize |

	[	
	10 timesRepeat: [Smalltalk garbageCollect].
	metaclassesSize := Metaclass instanceCount.

	aClass := self newClassOrTrait.
	aClass compileSilently: 'foo ^ 42'.

	10 timesRepeat: [Smalltalk garbageCollect].
	self assert: (metaclassesSize + 1) equals: Metaclass instanceCount.

	self swapOutClass: aClass.
	10 timesRepeat: [Smalltalk garbageCollect].
	self assert: aClass mareaIsProxy. 
	DebuggerMethodMap cleanUp.
	10 timesRepeat: [Smalltalk garbageCollect].
	"I comment this line because sometimes it works and sometimes it doesnt. However, if I close the test, run a garbage collect from outside, the instaces are garbage collected. So I think it is something related to the tests"
	"self assert: metaclassesSize equals: Metaclass instanceCount."
	
	self swapIn: aClass.	
	10 timesRepeat: [Smalltalk garbageCollect].
	self assert: (metaclassesSize + 1) equals: Metaclass instanceCount.
	
	 ] ensure: [ aClass mareaIsProxy ifTrue: [ self swapIn: aClass.  ] ]! !

!MARClassSwappingTest methodsFor: 'tests class swapping' stamp: 'MarianoMartinezPeck 1/5/2012 11:28'!
testSuperclassClassVariableAndSwapoutTwoSubclasses

	| aClass anObject aSubclass anotherSubclass |

	anObject := (ClassWith1Var var1: 'foo').
	aClass := self newClassOrTrait.
	aClass compileSilently: 'foo ^ 42'.
	aClass addClassVarNamed: 'ClassVar1'.
	aClass class compileSilently: 'classVar1 ^ ClassVar1'.
	aClass class compileSilently: 'classVar1: a  ClassVar1 := a'.
	aClass perform: #classVar1: with: anObject.

	aSubclass := self newClassOrTraitSubclassOf: aClass.
	aSubclass class compileSilently: 'bar1 ^ ClassVar1 '.

	anotherSubclass := self newClassOrTraitSubclassOf: aClass.
	anotherSubclass class compileSilently: 'bar2 ^ ClassVar1 '.

	self assert: (aSubclass perform: #bar1) == anObject. 
	self assert: (anotherSubclass perform: #bar2) == anObject. 

	self swapOutClass: aSubclass.
	self swapOutClass: anotherSubclass.
	
	self assert: (aSubclass perform: #bar1) == anObject. 
	self assert: (anotherSubclass perform: #bar2) == anObject. 
! !

!MARClassSwappingTest methodsFor: 'tests class swapping' stamp: 'MarianoMartinezPeck 1/5/2012 11:28'!
testSwapOutClassAndSwapInByMethodExecutionOfAnotherClass

	| aClass aClassName  anotherClass   |

	aClass := self newClassOrTrait.
	aClass class compileSilently: 'foo: something   ^ 42 + something'.
	aClassName := aClass name asString.
	
	anotherClass := self newClassOrTrait.
	anotherClass class compileSilently: 'bar ^ ', aClassName , ' foo: 1 '.


	self assert: (anotherClass perform: #bar) = 43. 
	self assert: (aClass perform: #foo: with: 2) = 44. 

	self swapOutClass: aClass.
	
	self assert: (anotherClass perform: #bar) = 43. 
	self assert: (aClass perform: #foo: with: 2) = 44.
! !

!MARClassSwappingTest methodsFor: 'tests class swapping' stamp: 'MarianoMartinezPeck 1/5/2012 11:28'!
testSwapOutClassAndTestMetaclassIsProxified
	| aClass aClassCopy aClassClassCopy metaclass |

	aClass := self newClassOrTrait.
	aClass class compileSilently: 'foo ^ 42'.
	aClassClassCopy := aClass class veryDeepCopy.
	metaclass := aClass class. 

	self swapOutClass: aClass.

	self assert: aClass mareaIsProxy. 
	self assert: metaclass mareaIsProxy. 
	
	self swapIn: aClass.	

	self deny: aClass mareaIsProxy. 
	self deny: aClass class mareaIsProxy. 

	self assert: aClass class name equals: aClassClassCopy name.
	self assert: aClass class methodDict equals: aClassClassCopy methodDict.
	self assert: aClass class subclasses equals: aClassClassCopy subclasses.
	self assert: aClass class format equals: aClassClassCopy format.! !

!MARClassSwappingTest methodsFor: 'tests class swapping' stamp: 'MarianoMartinezPeck 1/5/2012 11:28'!
testSwapOutClassSwapInByClass

	| aClass aClassCopy |

	aClass := self newClassOrTrait.
	aClass compileSilently: 'foo ^ 42'.
	aClassCopy	:= aClass veryDeepCopy.

	self swapOutClass: aClass.

	self assert: aClass mareaIsProxy. 
	
	self swapIn: aClass.	

	self deny: aClass mareaIsProxy. 
	self assert: aClass name equals: aClassCopy name.
	self assert: aClass methodDict equals: aClassCopy methodDict.
	self assert: aClass subclasses equals: aClassCopy subclasses.
	self assert: aClass format equals: aClassCopy format.
! !

!MARClassSwappingTest methodsFor: 'tests class swapping' stamp: 'MarianoMartinezPeck 1/5/2012 11:28'!
testSwapOutClassSwapInByClassPool

	| aClass aClassCopy aClassClassPool |

	aClass := self newClassOrTrait.
	aClass compileSilently: 'foo ^ 42'.
	aClass addClassVarNamed: 'Something'.
	aClass class compileSilently: 'something ^ Something'.
	aClass class compileSilently: 'something: a  Something := a'.
	aClassCopy	:= aClass veryDeepCopy.
	aClass perform: #something: with: (ClassWith1Var var1: 'foo').
	aClassClassPool := aClass classPool at: #Something.

	self swapOutClass: aClass.

	self assert: aClass mareaIsProxy. 
	self assert: aClassClassPool mareaIsProxy. 
	
	self swapIn: aClassClassPool.	

	self deny: aClass mareaIsProxy. 
	self deny: aClassClassPool mareaIsProxy.
	self assert: aClassClassPool var1 = 'foo'.
	self assert: aClass name equals: aClassCopy name.
	self assert: aClass methodDict equals: aClassCopy methodDict.
	self assert: aClass subclasses equals: aClassCopy subclasses.
	self assert: aClass format equals: aClassCopy format.
! !

!MARClassSwappingTest methodsFor: 'tests class swapping' stamp: 'MarianoMartinezPeck 1/5/2012 11:28'!
testSwapOutClassSwapInByInstance

	| aClass aClassCopy instance |

	aClass := self newClassWithInstanceVariableNames: 'foo'.
	aClass compileSilently: 'foo ^ foo'.
	aClass compileSilently: 'foo: aFoo 
					foo := aFoo'.
	instance := aClass new.
	instance perform: #foo: with: 42.
	aClassCopy	:= aClass veryDeepCopy.

	self swapOutClass: aClass.

	self assert: aClass mareaIsProxy. 
	
	instance mareaIsProxy.	

	self assert: (instance perform: #foo) = 42.
	self assert: instance class == aClass.
	self deny: aClass mareaIsProxy. 
	self assert: aClass name equals: aClassCopy name.
	self assert: aClass methodDict equals: aClassCopy methodDict.
	self assert: aClass subclasses equals: aClassCopy subclasses.
	self assert: aClass format equals: aClassCopy format.
	
! !

!MARClassSwappingTest methodsFor: 'tests class swapping' stamp: 'MarianoMartinezPeck 1/5/2012 11:28'!
testSwapOutClassSwapInByMetaclass

	| aClass aClassCopy metaclass aClassClassCopy |

	aClass := self newClassOrTrait.
	aClass compileSilently: 'foo ^ 42'.
	aClassCopy	:= aClass veryDeepCopy.
	metaclass := aClass class.
	aClassClassCopy := metaclass veryDeepCopy.
	
	self swapOutClass: aClass.

	self assert: aClass mareaIsProxy. 
	
	self swapIn: metaclass.	

	self deny: aClass mareaIsProxy. 
	self assert: aClass name equals: aClassCopy name.
	self assert: aClass methodDict equals: aClassCopy methodDict.
	self assert: aClass subclasses equals: aClassCopy subclasses.
	self assert: aClass format equals: aClassCopy format.

	self assert: aClass class name equals: aClassClassCopy name.
	self assert: aClass class methodDict equals: aClassClassCopy methodDict.
	self assert: aClass class subclasses equals: aClassClassCopy subclasses.
	self assert: aClass class format equals: aClassClassCopy format.! !

!MARClassSwappingTest methodsFor: 'tests class swapping' stamp: 'MarianoMartinezPeck 1/5/2012 11:28'!
testSwapOutClassThenSwapOutSometihingWithAClassPool

	| aClass aClassCopy aClassName anObject aClassClassPool |

	aClass := self newClassOrTrait.
	aClass compileSilently: 'foo ^ 42'.
	aClass addClassVarNamed: 'Something'.
	aClass class compileSilently: 'something ^ Something'.
	aClass class compileSilently: 'something: a  Something := a'.
	aClassCopy	:= aClass veryDeepCopy.
	aClass perform: #something: with: (ClassWith1Var var1: 'foo').
	aClassClassPool := aClass classPool at: #Something.

	anObject := ClassWith2Var new.
	anObject var1: 'foo'.
	anObject var2: aClassClassPool.
	
	self swapOut: anObject.
	self assert: anObject mareaIsProxy. 
	self assert: aClassClassPool mareaIsProxy. 
	

	self swapOutClass: aClass.
	
	self assert: aClass mareaIsProxy. 
	self assert: anObject mareaIsProxy. 
	self assert: aClassClassPool mareaIsProxy. 
	

	self swapIn: aClassClassPool.	

	self deny: anObject mareaIsProxy. 
	self deny: aClassClassPool mareaIsProxy. 
	self assert: aClass mareaIsProxy. 
	
	self assert: anObject var1 = 'foo'.
	self assert: aClassClassPool var1 = 'foo'.
	
	self swapIn: aClass.

	self deny: aClass mareaIsProxy. 	
		
	self assert: (aClass classPool at: #Something) == aClassClassPool.
	self assert: aClass name equals: aClassCopy name.
	self assert: aClass methodDict equals: aClassCopy methodDict.
	self assert: aClass subclasses equals: aClassCopy subclasses.
	self assert: aClass format equals: aClassCopy format.
	self assert: anObject var2 == aClassClassPool.
! !

!MARClassSwappingTest methodsFor: 'tests class swapping' stamp: 'MarianoMartinezPeck 1/5/2012 11:28'!
testSwapOutClassThenSwapOutSometihingWithAClassPool2

	| aClass aClassCopy aClassName anObject aClassClassPool |

	aClass := self newClassOrTrait.
	aClass compileSilently: 'foo ^ 42'.
	aClass addClassVarNamed: 'Something'.
	aClass class compileSilently: 'something ^ Something'.
	aClass class compileSilently: 'something: a  Something := a'.
	aClassCopy	:= aClass veryDeepCopy.
	aClass perform: #something: with: (ClassWith1Var var1: 'foo').
	aClassClassPool := aClass classPool at: #Something.

	anObject := ClassWith2Var new.
	anObject var1: 'foo'.
	anObject var2: aClassClassPool.


	self swapOutClass: aClass.

	self assert: aClass mareaIsProxy. 
	self assert: aClassClassPool mareaIsProxy. 

	
	self swapOut: anObject.
	self assert: anObject mareaIsProxy. 
	self assert: aClass mareaIsProxy. 
	self assert: aClassClassPool mareaIsProxy. 
	
	
	self swapIn: aClassClassPool.	

	self deny: aClass mareaIsProxy. 
	self deny: aClassClassPool mareaIsProxy. 
	self assert: anObject mareaIsProxy. 
	
	self swapIn: anObject.

	self deny: anObject mareaIsProxy. 	
	
	self assert: anObject var1 = 'foo'.
	self assert: aClassClassPool var1 = 'foo'.
	
		
	self assert: (aClass classPool at: #Something) == aClassClassPool.
	self assert: aClass name equals: aClassCopy name.
	self assert: aClass methodDict equals: aClassCopy methodDict.
	self assert: aClass subclasses equals: aClassCopy subclasses.
	self assert: aClass format equals: aClassCopy format.
	self assert: anObject var2 == aClassClassPool.
! !

!MARClassSwappingTest methodsFor: 'tests class swapping' stamp: 'MarianoMartinezPeck 1/5/2012 11:28'!
testSwapOutClassThenSwapOutSometihingWithItAsGlobal

	| aClass aClassCopy aClassName anObject |

	aClass := self newClassOrTrait.
	aClass compileSilently: 'foo ^ 42'.
	aClassCopy	:= aClass veryDeepCopy.
	aClassName := aClass name.

	self swapOutClass: aClass.

	self assert: aClass mareaIsProxy. 
	
	anObject := ClassWith2Var new.
	anObject var1: 'foo'.
	anObject var2: (Smalltalk at: aClassName).
	
	self swapOut: anObject.
	self assert: anObject mareaIsProxy. 
	
	self swapIn: anObject.	
	
	self deny: anObject mareaIsProxy. 
	self assert: anObject var1 = 'foo'.
	self assert: aClass mareaIsProxy. 
	
	self swapIn: aClass.

	self deny: aClass mareaIsProxy. 	
	self assert: aClass name equals: aClassCopy name.
	self assert: aClass methodDict equals: aClassCopy methodDict.
	self assert: aClass subclasses equals: aClassCopy subclasses.
	self assert: aClass format equals: aClassCopy format.
	self assert: anObject var2 == aClass.
! !

!MARClassSwappingTest methodsFor: 'tests class swapping' stamp: 'MarianoMartinezPeck 1/5/2012 11:28'!
testSwapOutClassThenSwapOutSometihingWithItAsGlobal2

	| aClass aClassCopy aClassName anObject |

	aClass := self newClassOrTrait.
	aClass compileSilently: 'foo ^ 42'.
	aClassCopy	:= aClass veryDeepCopy.
	aClassName := aClass name.

	self swapOutClass: aClass.

	self assert: aClass mareaIsProxy. 
	
	anObject := ClassWith2Var new.
	anObject var1: 'foo'.
	anObject var2: (Smalltalk at: aClassName).
	
	self swapOut: anObject.
	self assert: anObject mareaIsProxy. 
	
	self swapIn: anObject.	

	self deny: anObject mareaIsProxy. 
	self assert: anObject var1 = 'foo'.
	self assert: aClass mareaIsProxy. 
	
	self swapIn: anObject var2.

	self deny: aClass mareaIsProxy. 	
	self assert: aClass name equals: aClassCopy name.
	self assert: aClass methodDict equals: aClassCopy methodDict.
	self assert: aClass subclasses equals: aClassCopy subclasses.
	self assert: aClass format equals: aClassCopy format.
	self assert: anObject var2 == aClass.
! !

!MARClassSwappingTest methodsFor: 'tests class swapping' stamp: 'MarianoMartinezPeck 1/5/2012 11:28'!
testSwapOutClassThenSwapOutSometihingWithItAsGlobal3

	| aClass aClassCopy aClassName anObject |

	aClass := self newClassOrTrait.
	aClass compileSilently: 'foo ^ 42'.
	aClassCopy	:= aClass veryDeepCopy.
	aClassName := aClass name.

	self swapOutClass: aClass.

	self assert: aClass mareaIsProxy. 
	
	anObject := ClassWith2Var new.
	anObject var1: 'foo'.
	anObject var2: (Smalltalk at: aClassName).
	
	self swapOut: anObject.
	self assert: anObject mareaIsProxy. 
	
	self swapIn: aClass.

	self deny: aClass mareaIsProxy. 	
	self assert: aClass name equals: aClassCopy name.
	self assert: aClass methodDict equals: aClassCopy methodDict.
	self assert: aClass subclasses equals: aClassCopy subclasses.
	self assert: aClass format equals: aClassCopy format.
	
	self swapIn: anObject.	
		
	self deny: anObject mareaIsProxy. 
	self assert: anObject var1 = 'foo'.
	self assert: anObject var2 == aClass.
	

! !

!MARClassSwappingTest methodsFor: 'tests class swapping' stamp: 'MarianoMartinezPeck 1/5/2012 11:28'!
testSwapOutClassWithLiveInstance

	| aClass aClassCopy instance |

	aClass := self newClassWithInstanceVariableNames: 'foo'.
	aClass compileSilently: 'foo ^ foo'.
	aClass compileSilently: 'foo: aFoo 
					foo := aFoo'.
	instance := aClass new.
	instance perform: #foo: with: 42.
	aClassCopy	:= aClass veryDeepCopy.

	self swapOutClass: aClass.

	self assert: aClass mareaIsProxy. 
	
	self swapIn: aClass.	

	self deny: aClass mareaIsProxy. 
	self assert: aClass name equals: aClassCopy name.
	self assert: aClass methodDict equals: aClassCopy methodDict.
	self assert: aClass subclasses equals: aClassCopy subclasses.
	self assert: aClass format equals: aClassCopy format.
	self assert: instance class == aClass.
	self assert: (instance perform: #foo) = 42.
! !

!MARClassSwappingTest methodsFor: 'tests class swapping' stamp: 'MarianoMartinezPeck 1/5/2012 11:28'!
testSwapOutClassWithSubclassSwapInBySubclass

	| aClass aClassCopy aClassSubclass |

	aClass := self newClassOrTrait.
	aClass compileSilently: 'foo ^ 42'.
	aClassSubclass := self newClassOrTraitSubclassOf: aClass.
	
	aClassCopy	:= aClass veryDeepCopy.

	self swapOutClass: aClass.

	self assert: aClass mareaIsProxy. 
	
	self swapIn: aClassSubclass.	

	self deny: aClass mareaIsProxy. 
	self assert: aClass name equals: aClassCopy name.
	self assert: aClass methodDict equals: aClassCopy methodDict.
	self assert: aClass subclasses equals: aClassCopy subclasses.
	self assert: aClass format equals: aClassCopy format.
	self assert: aClassSubclass new foo equals: 42.
! !

!MARClassSwappingTest methodsFor: 'tests class swapping' stamp: 'MarianoMartinezPeck 1/5/2012 11:28'!
testSwapOutClassWithSubclassSwapInBySubclassInstance

	| aClass aClassCopy aClassSubclass aSubclassInstance |

	aClass := self newClassOrTrait.
	aClass compileSilently: 'foo ^ 42'.
	aClassSubclass := self newClassOrTraitSubclassOf: aClass.
	aSubclassInstance := aClassSubclass new. 
	
	aClassCopy	:= aClass veryDeepCopy.

	self swapOutClass: aClass.

	self assert: aClass mareaIsProxy. 
	
	self swapIn: aSubclassInstance.	

	self deny: aClass mareaIsProxy. 
	self assert: aClass name equals: aClassCopy name.
	self assert: aClass methodDict equals: aClassCopy methodDict.
	self assert: aClass subclasses equals: aClassCopy subclasses.
	self assert: aClass format equals: aClassCopy format.
	self assert: aSubclassInstance foo equals: 42.
! !

!MARClassSwappingTest methodsFor: 'tests class swapping' stamp: 'MarianoMartinezPeck 1/5/2012 11:28'!
testSwapOutClassWithSubclassSwapInBySubclassMetaclass

	| aClass aClassCopy aClassSubclass aClassSubclassMetaclass |

	aClass := self newClassOrTrait.
	aClass compileSilently: 'foo ^ 42'.
	aClassSubclass := self newClassOrTraitSubclassOf: aClass.
	aClassSubclassMetaclass := aClassSubclass class.
	
	aClassCopy	:= aClass veryDeepCopy.

	self swapOutClass: aClass.

	self assert: aClass mareaIsProxy. 
	
	self swapIn: aClassSubclassMetaclass.	

	self deny: aClass mareaIsProxy. 
	self assert: aClass name equals: aClassCopy name.
	self assert: aClass methodDict equals: aClassCopy methodDict.
	self assert: aClass subclasses equals: aClassCopy subclasses.
	self assert: aClass format equals: aClassCopy format.
	self assert: aClassSubclass new foo equals: 42.
! !

!MARClassSwappingTest methodsFor: 'tests class swapping' stamp: 'MarianoMartinezPeck 2/4/2012 15:03'!
testSwapOutExistingClassSwapInByClass

	| aClass aClassCopy |

	aClass := HelpBrowser.
	aClassCopy	:= aClass veryDeepCopy.

	self swapOutClass: aClass.

	self assert: aClass mareaIsProxy. 
	
	self swapIn: aClass.	

	self deny: aClass mareaIsProxy. 
	self assert: aClass name equals: aClassCopy name.
	self assert: aClass methodDict equals: aClassCopy methodDict.
	self assert: aClass subclasses equals: aClassCopy subclasses.
	self assert: aClass format equals: aClassCopy format.
! !

MARBaseObjectGraphSwapperTest subclass: #MARClassSwappingWithInstancesTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MareaTests-Swapping'!

!MARClassSwappingWithInstancesTest methodsFor: 'tests class swapping instances' stamp: 'MarianoMartinezPeck 1/5/2012 11:28'!
testProxyUninstalledWhileSwappingOut

	| aClass aClassCopy instance anotherInstance anotherClass anotherClassInstance object aClassInstance |

	object := Object new.
	
	aClass := self newClassWithInstanceVariableNames: 'foo bar'.
	aClass compileSilently: 'foo ^ [ bar. ]'.
	aClass compileSilently: 'bar: aBar  bar := aBar '.
	aClass compileSilently: 'bar ^ bar '.
	aClassInstance := aClass new.
	aClassInstance perform: #bar: with: object.
		
	anotherClass :=  self newClassWithInstanceVariableNames: 'foo2 bar2'.
	anotherClass compileSilently: 'foo2: aFoo 
					foo2 := aFoo'.	
		anotherClass compileSilently: 'bar2: aBar 
					bar2 := aBar'.
	anotherClass compileSilently: 'bar2 ^ bar2'. 
	anotherClass compileSilently: 'foo2 ^ foo2'.
					
	anotherClassInstance := anotherClass new. 
	anotherClassInstance perform: #foo2: with: aClassInstance foo.
	anotherClassInstance perform: #bar2: with: aClassInstance bar.
		

	self swapOutClassWithInstances: aClass.
	self swapOutClassWithInstances: anotherClass.


	self deny: aClass mareaIsProxy. 
	self assert: anotherClass mareaIsProxy. 

	self swapIn: anotherClass.

	self deny: aClass mareaIsProxy. 
	self deny: anotherClass mareaIsProxy. 
	self assert: (anotherClassInstance perform: #foo2) method == (aClassInstance perform: #foo) method
! !

!MARClassSwappingWithInstancesTest methodsFor: 'tests class swapping instances' stamp: 'MarianoMartinezPeck 1/5/2012 11:28'!
testProxyUninstalledWhileSwappingOut2

	| aClass aClassCopy instance anotherInstance anotherClass anotherClassInstance object aClassInstance |

	object := Object new.
	
	aClass := self newClassWithInstanceVariableNames: 'foo bar'.
	aClass compileSilently: 'foo ^ [ bar. ]'.
	aClass compileSilently: 'bar: aBar  bar := aBar '.
	aClass compileSilently: 'bar ^ bar '.
	aClassInstance := aClass new.
	aClassInstance perform: #bar: with: object.
		
	anotherClass :=  self newClassWithInstanceVariableNames: 'foo2 bar2'.
	anotherClass compileSilently: 'foo2: aFoo 
					foo2 := aFoo'.	
		anotherClass compileSilently: 'bar2: aBar 
					bar2 := aBar'.
	anotherClass compileSilently: 'bar2 ^ bar2'. 
	anotherClass compileSilently: 'foo2 ^ foo2'.
					
	anotherClassInstance := anotherClass new. 
	anotherClassInstance perform: #foo2: with: aClassInstance foo.
	anotherClassInstance perform: #bar2: with: aClassInstance bar.
		
	"This will make that the method pointed from the closure of anotherClassInstance foo2, to be uninstalled. "
	aClass compileSilently: 'foo Transcript show: 42. ^  [ bar. ]'.

	self swapOutClassWithInstances: aClass.
	self swapOutClassWithInstances: anotherClass.
	
	self assert: aClass mareaIsProxy. 
	self assert: anotherClass mareaIsProxy. 
	
	self swapIn: anotherClass.
	self assert: aClass mareaIsProxy. 
	self deny: anotherClass mareaIsProxy. 

	self swapIn: aClass.
	self deny: aClass mareaIsProxy. 
	self deny: anotherClass mareaIsProxy. 
! !

!MARClassSwappingWithInstancesTest methodsFor: 'tests class swapping instances' stamp: 'MarianoMartinezPeck 1/5/2012 11:28'!
testSwapOupSuperclassAndSubclassWithSubclassInByClass

	| aClass anObject aSubclass anotherSubclass anInstance aSubclassInstance aSubclassSubclass aSubclassSubclassInstance |

	aClass := self newClassOrTrait.
	anInstance := aClass new.
	aSubclass := self newClassOrTraitSubclassOf: aClass.
	aSubclassInstance := aSubclass new.
	aSubclassSubclass := self newClassOrTraitSubclassOf: aSubclass.		
	aSubclassSubclassInstance := aSubclassSubclass new.

	self swapOutClassWithInstances: aClass.
	self swapIn: aClass.! !

!MARClassSwappingWithInstancesTest methodsFor: 'tests class swapping instances' stamp: 'MarianoMartinezPeck 1/5/2012 11:28'!
testSwapOutClassWithInstancesSwapInByClass

	| aClass aClassCopy instance anotherInstance |

	aClass := self newClassWithInstanceVariableNames: 'foo'.
	aClass compileSilently: 'foo ^ foo'.
	aClass compileSilently: 'foo: aFoo 
					foo := aFoo'.
	instance := aClass new.
	instance perform: #foo: with: 42.
	anotherInstance := aClass new.	
	aClassCopy	:= aClass veryDeepCopy.

	self swapOutClassWithInstances: aClass.

	self assert: aClass mareaIsProxy. 
	self assert: instance mareaIsProxy. 
	self assert: anotherInstance mareaIsProxy. 

	self swapIn: aClass.

	self deny: aClass mareaIsProxy. 
	self deny: instance mareaIsProxy. 
	self deny: anotherInstance mareaIsProxy. 
	self assert: (instance perform: #foo) = 42.
	self assert: instance class == aClass.
	self assert: anotherInstance class == aClass.
	self assert: aClass name equals: aClassCopy name.
	self assert: aClass methodDict equals: aClassCopy methodDict.
	self assert: aClass subclasses equals: aClassCopy subclasses.
	self assert: aClass format equals: aClassCopy format.
	
! !

!MARClassSwappingWithInstancesTest methodsFor: 'tests class swapping instances' stamp: 'MarianoMartinezPeck 1/5/2012 11:28'!
testSwapOutClassWithInstancesSwapInByInstance

	| aClass aClassCopy instance anotherInstance |

	aClass := self newClassWithInstanceVariableNames: 'foo'.
	aClass compileSilently: 'foo ^ foo'.
	aClass compileSilently: 'foo: aFoo 
					foo := aFoo'.
	instance := aClass new.
	instance perform: #foo: with: 42.
	anotherInstance := aClass new.	
	aClassCopy	:= aClass veryDeepCopy.

	self swapOutClassWithInstances: aClass.

	self assert: aClass mareaIsProxy. 
	self assert: instance mareaIsProxy. 
	self assert: anotherInstance mareaIsProxy. 

	self swapIn: instance.

	self deny: aClass mareaIsProxy. 
	self deny: instance mareaIsProxy. 
	self deny: anotherInstance mareaIsProxy. 
	self assert: (instance perform: #foo) = 42.
	self assert: instance class == aClass.
	self assert: anotherInstance class == aClass.
	self assert: aClass name equals: aClassCopy name.
	self assert: aClass methodDict equals: aClassCopy methodDict.
	self assert: aClass subclasses equals: aClassCopy subclasses.
	self assert: aClass format equals: aClassCopy format.
	
! !

!MARClassSwappingWithInstancesTest methodsFor: 'tests class swapping instances' stamp: 'MarianoMartinezPeck 1/5/2012 11:28'!
testSwapOutClassWithInstancesSwapInByMetaclass

	| aClass aClassClass aClassCopy instance anotherInstance |

	aClass := self newClassWithInstanceVariableNames: 'foo'.
	aClass compileSilently: 'foo ^ foo'.
	aClass compileSilently: 'foo: aFoo 
					foo := aFoo'.
	aClassClass := aClass class.
	instance := aClass new.
	instance perform: #foo: with: 42.
	anotherInstance := aClass new.	
	aClassCopy	:= aClass veryDeepCopy.

	self swapOutClassWithInstances: aClass.

	self assert: aClass mareaIsProxy. 
	self assert: aClassClass mareaIsProxy. 
	self assert: instance mareaIsProxy. 
	self assert: anotherInstance mareaIsProxy. 
	
	self swapIn: aClassClass.

	self deny: aClass mareaIsProxy. 
	self deny: aClassClass mareaIsProxy. 
	self deny: instance mareaIsProxy. 
	self deny: anotherInstance mareaIsProxy. 
	self assert: (instance perform: #foo) = 42.
	self assert: instance class == aClass.
	self assert: anotherInstance class == aClass.
	self assert: aClass name equals: aClassCopy name.
	self assert: aClass methodDict equals: aClassCopy methodDict.
	self assert: aClass subclasses equals: aClassCopy subclasses.
	self assert: aClass format equals: aClassCopy format.
	
! !

!MARClassSwappingWithInstancesTest methodsFor: 'tests class swapping instances' stamp: 'MarianoMartinezPeck 1/5/2012 11:28'!
testSwapOutClassWithSubclassesAndInstancesSwapInByClass

	| aClass anObject aSubclass anotherSubclass aClassClass instance aClassCopy aSubclassClass aSubclassInstance |

	aClass := self newClassWithInstanceVariableNames: 'foo'.
	aClass compileSilently: 'foo ^ foo'.
	aClass compileSilently: 'foo: aFoo 
					foo := aFoo'.
	aClassClass := aClass class.
	instance := aClass new.
	instance perform: #foo: with: 42.
	aClassCopy	:= aClass veryDeepCopy.

	aSubclass := self newClassOrTraitSubclassOf: aClass.
	aSubclassClass := aSubclass class.
	aSubclassInstance := aSubclass new. 

	self swapOutClassWithInstances: aClass.

	self assert: aClass mareaIsProxy. 
	self assert: aClassClass mareaIsProxy. 
	self assert: instance mareaIsProxy. 
	self assert: aSubclass mareaIsProxy.
	self assert: aSubclassClass mareaIsProxy.
	self assert: aSubclassInstance mareaIsProxy.

	self swapIn: aClass.
	
	self deny: aClass mareaIsProxy. 
	self deny: aClassClass mareaIsProxy. 
	self deny: instance mareaIsProxy. 
	self deny: aSubclass mareaIsProxy.
	self deny: aSubclassClass mareaIsProxy.
	self deny: aSubclassInstance mareaIsProxy.
	
	self assert: aSubclass superclass == aClass.
	self assert: instance class == aClass.
	self assert: aSubclassInstance class == aSubclass.
	self assert: (aClass subclasses identityIncludes: aSubclass).! !

!MARClassSwappingWithInstancesTest methodsFor: 'tests class swapping instances' stamp: 'MarianoMartinezPeck 1/5/2012 11:28'!
testSwapOutClassWithSubclassesAndInstancesSwapInBySubclass

	| aClass anObject aSubclass anotherSubclass aClassClass instance aClassCopy aSubclassClass aSubclassInstance |

	aClass := self newClassWithInstanceVariableNames: 'foo'.
	aClass compileSilently: 'foo ^ foo'.
	aClass compileSilently: 'foo: aFoo 
					foo := aFoo'.
	aClassClass := aClass class.
	instance := aClass new.
	instance perform: #foo: with: 42.
	aClassCopy	:= aClass veryDeepCopy.

	aSubclass := self newClassOrTraitSubclassOf: aClass.
	aSubclassClass := aSubclass class.
	aSubclassInstance := aSubclass new. 

	self swapOutClassWithInstances: aClass.

	self assert: aClass mareaIsProxy. 
	self assert: aClassClass mareaIsProxy. 
	self assert: instance mareaIsProxy. 
	self assert: aSubclass mareaIsProxy.
	self assert: aSubclassClass mareaIsProxy.
	self assert: aSubclassInstance mareaIsProxy.

	self swapIn: aSubclass.
	
	self deny: aClass mareaIsProxy. 
	self deny: aClassClass mareaIsProxy. 
	self deny: instance mareaIsProxy. 
	self deny: aSubclass mareaIsProxy.
	self deny: aSubclassClass mareaIsProxy.
	self deny: aSubclassInstance mareaIsProxy.
	
	self assert: aSubclass superclass == aClass.
	self assert: instance class == aClass.
	self assert: aSubclassInstance class == aSubclass.
	self assert: (aClass subclasses identityIncludes: aSubclass).! !

!MARClassSwappingWithInstancesTest methodsFor: 'tests class swapping instances' stamp: 'MarianoMartinezPeck 1/5/2012 11:28'!
testSwapOutClassWithSubclassesAndInstancesSwapInBySubclassInstance

	| aClass anObject aSubclass anotherSubclass aClassClass instance aClassCopy aSubclassClass aSubclassInstance |

	aClass := self newClassWithInstanceVariableNames: 'foo'.
	aClass compileSilently: 'foo ^ foo'.
	aClass compileSilently: 'foo: aFoo 
					foo := aFoo'.
	aClassClass := aClass class.
	instance := aClass new.
	instance perform: #foo: with: 42.
	aClassCopy	:= aClass veryDeepCopy.

	aSubclass := self newClassOrTraitSubclassOf: aClass.
	aSubclassClass := aSubclass class.
	aSubclassInstance := aSubclass new. 

	self swapOutClassWithInstances: aClass.

	self assert: aClass mareaIsProxy. 
	self assert: aClassClass mareaIsProxy. 
	self assert: instance mareaIsProxy. 
	self assert: aSubclass mareaIsProxy.
	self assert: aSubclassClass mareaIsProxy.
	self assert: aSubclassInstance mareaIsProxy.

	self swapIn: aSubclassInstance.
	
	self deny: aClass mareaIsProxy. 
	self deny: aClassClass mareaIsProxy. 
	self deny: instance mareaIsProxy. 
	self deny: aSubclass mareaIsProxy.
	self deny: aSubclassClass mareaIsProxy.
	self deny: aSubclassInstance mareaIsProxy.
	
	self assert: aSubclass superclass == aClass.
	self assert: instance class == aClass.
	self assert: aSubclassInstance class == aSubclass.
	self assert: (aClass subclasses identityIncludes: aSubclass).! !

MARBaseObjectGraphSwapperTest subclass: #MARClassSwappingWithSubclassesTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MareaTests-Swapping'!

!MARClassSwappingWithSubclassesTest methodsFor: 'tests subclasses' stamp: 'MarianoMartinezPeck 1/5/2012 11:30'!
testClasshasProxifiedSubclass

	| aClass anObject aSubclass aClassInstance |

	anObject := (ClassWith1Var var1: 'foo').
	aClass := self newClassOrTrait.

	aSubclass := self newClassOrTraitSubclassOf: aClass.
	aSubclass class compileSilently: 'bar1 ^ ClassVar1 '.

	self swapOutClass: aSubclass.

	self deny: aClass mareaIsProxy.
	self assert: aSubclass mareaIsProxy.
	self assert: aClass hasProxifiedSubclass.
	! !

!MARClassSwappingWithSubclassesTest methodsFor: 'tests subclasses' stamp: 'MarianoMartinezPeck 1/5/2012 11:30'!
testClasshasProxifiedSubclassAndSubclasses

	| aClass anObject aSubclass aClassInstance aSubclassSubclass |

	anObject := (ClassWith1Var var1: 'foo').
	aClass := self newClassOrTrait.

	aSubclass := self newClassOrTraitSubclassOf: aClass.
	aSubclassSubclass := self newClassOrTraitSubclassOf: aSubclass.

	self swapOutClass: aSubclassSubclass.

	self deny: aClass mareaIsProxy.
	self deny: aSubclass mareaIsProxy.
	self assert: aSubclassSubclass mareaIsProxy.
	self assert: aClass hasProxifiedSubclass.
	self assert: aSubclass hasProxifiedSubclass! !

!MARClassSwappingWithSubclassesTest methodsFor: 'tests subclasses' stamp: 'MarianoMartinezPeck 1/5/2012 11:30'!
testErrorClasshasProxifiedSubclass

	| aClass anObject aSubclass aClassInstance |

	anObject := (ClassWith1Var var1: 'foo').
	aClass := self newClassOrTrait.

	aSubclass := self newClassOrTraitSubclassOf: aClass.
	aSubclass class compileSilently: 'bar1 ^ ClassVar1 '.

	self swapOutClass: aSubclass.
	self should: [self swapOutClass: aClass] raise: MARClassHasProxifiedSubclass.! !

!MARClassSwappingWithSubclassesTest methodsFor: 'tests subclasses' stamp: 'MarianoMartinezPeck 1/5/2012 11:30'!
testSwapOupSuperclassAndSubclassInBySubclass

	| aClass anObject aSubclass anotherSubclass |

	anObject := (ClassWith1Var var1: 'foo').
	aClass := self newClassOrTrait.
	aClass compileSilently: 'foo ^ 42'.
	aClass addClassVarNamed: 'ClassVar1'.
	aClass class compileSilently: 'classVar1 ^ ClassVar1'.
	aClass class compileSilently: 'classVar1: a  ClassVar1 := a'.
	aClass perform: #classVar1: with: anObject.

	aSubclass := self newClassOrTraitSubclassOf: aClass.
	aSubclass class compileSilently: 'bar1 ^ ClassVar1 '.

	self assert: (aSubclass perform: #bar1) == anObject. 

	self swapOutClass: aClass.

	self assert: aClass mareaIsProxy.
	self assert: aSubclass mareaIsProxy.
	
	self assert: (aSubclass perform: #bar1) == anObject. 
	self deny: aClass mareaIsProxy.
	self deny: aSubclass mareaIsProxy.
	self assert: aSubclass superclass == aClass.
	self assert: (aClass subclasses identityIncludes: aSubclass).! !

!MARClassSwappingWithSubclassesTest methodsFor: 'tests subclasses' stamp: 'MarianoMartinezPeck 1/5/2012 11:30'!
testSwapOupSuperclassAndSubclassInBySubclassInstance

	| aClass anObject aSubclass aSubclassInstance |

	anObject := (ClassWith1Var var1: 'foo').
	aClass := self newClassOrTrait.
	aClass compileSilently: 'foo ^ 42'.
	aClass addClassVarNamed: 'ClassVar1'.
	aClass class compileSilently: 'classVar1 ^ ClassVar1'.
	aClass class compileSilently: 'classVar1: a  ClassVar1 := a'.
	aClass perform: #classVar1: with: anObject.

	aSubclass := self newClassOrTraitSubclassOf: aClass.
	aSubclass class compileSilently: 'bar1 ^ ClassVar1 '.
	aSubclassInstance := aSubclass new.
	 
	self assert: (aSubclass perform: #bar1) == anObject. 

	self swapOutClass: aClass.

	self assert: aClass mareaIsProxy.
	self assert: aSubclass mareaIsProxy.
	
	aSubclassInstance name. 
	
	self deny: aClass mareaIsProxy.
	self deny: aSubclass mareaIsProxy.
	self assert: (aSubclass perform: #bar1) == anObject. 
	self assert: aSubclass superclass == aClass.
	self assert: (aClass subclasses identityIncludes: aSubclass).! !

!MARClassSwappingWithSubclassesTest methodsFor: 'tests subclasses' stamp: 'MarianoMartinezPeck 1/5/2012 11:30'!
testSwapOupSuperclassAndSubclassInBySubclassMetaclass

	| aClass anObject aSubclass anotherSubclass aSubclassClass |

	anObject := (ClassWith1Var var1: 'foo').
	aClass := self newClassOrTrait.
	aClass compileSilently: 'foo ^ 42'.
	aClass addClassVarNamed: 'ClassVar1'.
	aClass class compileSilently: 'classVar1 ^ ClassVar1'.
	aClass class compileSilently: 'classVar1: a  ClassVar1 := a'.
	aClass perform: #classVar1: with: anObject.

	aSubclass := self newClassOrTraitSubclassOf: aClass.
	aSubclass class compileSilently: 'bar1 ^ ClassVar1 '.
	aSubclassClass := aSubclass class.

	self assert: (aSubclass perform: #bar1) == anObject. 

	self swapOutClass: aClass.

	self assert: aClass mareaIsProxy.
	self assert: aSubclass mareaIsProxy.
	
	self swapIn: aSubclassClass.
	
	self deny: aClass mareaIsProxy.
	self deny: aSubclass mareaIsProxy.
	self assert: aSubclass superclass == aClass.
	self assert: (aClass subclasses identityIncludes: aSubclass).! !

!MARClassSwappingWithSubclassesTest methodsFor: 'tests subclasses' stamp: 'MarianoMartinezPeck 1/5/2012 11:30'!
testSwapOupSuperclassAndSubclassInBySuperclass

	| aClass anObject aSubclass anotherSubclass |

	anObject := (ClassWith1Var var1: 'foo').
	aClass := self newClassOrTrait.
	aClass compileSilently: 'foo ^ 42'.
	aClass addClassVarNamed: 'ClassVar1'.
	aClass class compileSilently: 'classVar1 ^ ClassVar1'.
	aClass class compileSilently: 'classVar1: a  ClassVar1 := a'.
	aClass perform: #classVar1: with: anObject.

	aSubclass := self newClassOrTraitSubclassOf: aClass.
	aSubclass class compileSilently: 'bar1 ^ ClassVar1 '.

	self assert: (aSubclass perform: #bar1) == anObject. 

	self swapOutClass: aClass.

	self assert: aClass mareaIsProxy.
	self assert: aSubclass mareaIsProxy.
	
	self swapIn: aClass.
	
	self deny: aClass mareaIsProxy.
	self deny: aSubclass mareaIsProxy.
	self assert: (aSubclass perform: #bar1) == anObject. 
	self assert: aSubclass superclass == aClass.
	self assert: (aClass subclasses identityIncludes: aSubclass).! !

!MARClassSwappingWithSubclassesTest methodsFor: 'tests subclasses' stamp: 'MarianoMartinezPeck 1/5/2012 11:30'!
testSwapOupSuperclassAndSubclassInBySuperclassInstance

	| aClass anObject aSubclass aClassInstance |

	anObject := (ClassWith1Var var1: 'foo').
	aClass := self newClassOrTrait.
	aClass compileSilently: 'foo ^ 42'.
	aClass addClassVarNamed: 'ClassVar1'.
	aClass class compileSilently: 'classVar1 ^ ClassVar1'.
	aClass class compileSilently: 'classVar1: a  ClassVar1 := a'.
	aClass perform: #classVar1: with: anObject.
	aClassInstance := aClass new.

	aSubclass := self newClassOrTraitSubclassOf: aClass.
	aSubclass class compileSilently: 'bar1 ^ ClassVar1 '.
	
	 
	self assert: (aSubclass perform: #bar1) == anObject. 

	self swapOutClass: aClass.

	self assert: aClass mareaIsProxy.
	self assert: aSubclass mareaIsProxy.
	
	aClass name. 
	
	self deny: aClass mareaIsProxy.
	self deny: aSubclass mareaIsProxy.
	self assert: (aSubclass perform: #bar1) == anObject. 
	self assert: aSubclass superclass == aClass.
	self assert: (aClass subclasses identityIncludes: aSubclass).! !

MARBaseObjectGraphSwapperTest subclass: #MARGeneralSwappingTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MareaTests-Swapping'!

!MARGeneralSwappingTest methodsFor: 'tests basic' stamp: 'MarianoMartinezPeck 1/5/2012 11:30'!
testAmountOfProxiesAndBecome
	"We test that we creat the right amount of proxies, that is, that after a GC runs, we should only have proxies for the root and the facade objects. In addition, we test we correctly did the become. "

	| a b proxiesCount |
	3 timesRepeat: [ Smalltalk garbageCollect ].
	proxiesCount := self regularObjectProxyClass instanceCount.
	a := ClassWith2Var new.
	b := ClassWith1Var new.	"Do not put a string or something like that because otherwise it is stored in the literals of the method and hence it is considered as a shared object"
	b var1: 6.
	a var1: (Point x: 4 y: 2).
	a var2: b.
	self swapOutAndClean: a.
	3 timesRepeat: [ Smalltalk garbageCollect ].	"One proxy for the root A and one proxy for the shared object B."
	self assert: self regularObjectProxyClass instanceCount equals: proxiesCount + 2.
	self assert: a mareaIsProxy.
	self assert: b mareaIsProxy! !

!MARGeneralSwappingTest methodsFor: 'tests specials' stamp: 'MarianoMartinezPeck 1/5/2012 11:31'!
testAmountOfProxiesAndBecomeWithSpecialObjects
	"We test that we creat the right amount of proxies, that is, that after a GC runs, we should only have proxies for the root and the facade objects. In addition, we test we correctly did the become. We should NOT create proxies for nil, true or false and some other special objects "
	| a b proxiesCount c |

	3 timesRepeat: [Smalltalk garbageCollect].
	proxiesCount := self regularObjectProxyClass instanceCount.

	a := OrderedCollection new.
	b := Smalltalk. 
	c := Processor.
	"Do not put a string or something like that because otherwise it is stored in the literals of the method and hence it is considered as a shared object"
	a add: b.
	a add: c.

	self swapOutAndClean: a
	.
	3 timesRepeat: [Smalltalk garbageCollect].
	self assert: self regularObjectProxyClass instanceCount equals: proxiesCount + 1.
	self assert: a mareaIsProxy. 
	
	self swapIn: a.	
	3 timesRepeat: [Smalltalk garbageCollect].

	"One proxy for the root A and NONE proxy for the shared object B because it is nil."
	self assert: self regularObjectProxyClass instanceCount equals: proxiesCount.
	self assert: a mareaClass = OrderedCollection. 
	self assert: b == Smalltalk. 
	self assert: b == a first.
	self assert: c == Processor.
	self assert: c == a second. 

	! !

!MARGeneralSwappingTest methodsFor: 'tests specials' stamp: 'MarianoMartinezPeck 1/5/2012 11:31'!
testAmountOfProxiesAndBecomeWithTrueNilFalse
	"We test that we creat the right amount of proxies, that is, that after a GC runs, we should only have proxies for the root and the facade objects. In addition, we test we correctly did the become. We should NOT create proxies for nil, true or false. "
	| a b proxiesCount c d |

	3 timesRepeat: [Smalltalk garbageCollect].
	proxiesCount := self regularObjectProxyClass instanceCount.

	a := OrderedCollection new.
	b := nil. 
	c := true.
	d := false.
	"Do not put a string or something like that because otherwise it is stored in the literals of the method and hence it is considered as a shared object"
	a add: b.
	a add: c.
	a add: d.

	self swapOutAndClean: a.
	3 timesRepeat: [Smalltalk garbageCollect].
	self assert: self regularObjectProxyClass instanceCount equals: proxiesCount + 1.
	self assert: a mareaIsProxy. 
	
	self swapIn: a.	
	3 timesRepeat: [Smalltalk garbageCollect].

	"One proxy for the root A and NONE proxy for the shared object B because it is nil."
	self assert: self regularObjectProxyClass instanceCount equals: proxiesCount.
	self assert: a class = OrderedCollection. 
	self assert: b isNil. 
	self assert: b == a first.
	self assert: c.
	self assert: c == a second. 
	self deny: d. 
	self assert: d == a third.
	
	! !

!MARGeneralSwappingTest methodsFor: 'tests global state cleaning' stamp: 'MarianoMartinezPeck 2/5/2012 22:02'!
testCleaningOnlyRemovesWhatNeeded

	| a b proxiesCount c |
	
	3 timesRepeat: [Smalltalk garbageCollect].

	a := ClassWith1Var new.
	b := (Point x: 4 y: 2).
	c := ClassWith1Var new. 
	c var1: b.
	a var1: b.

	self assert: MARObjectGraphSwapper globalSharedProxiesTable size equals: 0.
	self assert: MARObjectGraphSwapper globalGraphTable size equals: 0.
	
	self swapOut: a.
	self swapOut: c.
	
	self assert: MARObjectGraphSwapper globalSharedProxiesTable size equals: 1.
	self assert: MARObjectGraphSwapper globalGraphTable size equals: 2.
	self assert: (MARObjectGraphSwapper proxiesOfglobalGraphTableAt: 1) size equals: 2.
	self assert: (MARObjectGraphSwapper proxiesOfglobalGraphTableAt: 2) size equals: 2.

	MARObjectGraphSwapper clean. 
	3 timesRepeat: [Smalltalk garbageCollect].
	
	self assert: MARObjectGraphSwapper globalSharedProxiesTable size equals: 1.
	self assert: MARObjectGraphSwapper globalGraphTable size equals: 2.
	self assert: (MARObjectGraphSwapper proxiesOfglobalGraphTableAt: 1) size equals: 2.
	self assert: (MARObjectGraphSwapper proxiesOfglobalGraphTableAt: 2) size equals: 2.
! !

!MARGeneralSwappingTest methodsFor: 'tests error' stamp: 'MarianoMartinezPeck 1/5/2012 11:30'!
testErrorGraphIDBiggerThanMax
	"This works but it is too long to run it so I disable it"
	"self should: [ 32768 timesRepeat: [self swapOut: ClassWith1Var new] ] raise: MARGraphIDBiggerThanMax.
"! !

!MARGeneralSwappingTest methodsFor: 'tests error' stamp: 'MarianoMartinezPeck 2/5/2012 12:43'!
testErrorGraphPositionBiggerThanMax

	| anObject |

	anObject := OrderedCollection new.
	131072 timesRepeat:  [anObject add: ClassWith1Var new].
	self should: [self swapOut: anObject] raise: MARPositionBiggerThanMax.

	anObject := OrderedCollection new.
	130000 timesRepeat:  [anObject add: ClassWith1Var new].
	self shouldnt: [self swapOut: anObject] raise: MARPositionBiggerThanMax! !

!MARGeneralSwappingTest methodsFor: 'tests error' stamp: 'MarianoMartinezPeck 1/5/2012 11:30'!
testErrorSwapOutClassAlreadyProxified

	| anObject |

	anObject := ClassWith1Var new.

	self swapOut: anObject.
	self should: [self swapOutClass: anObject] raise: MARObjectAlreadyProxified! !

!MARGeneralSwappingTest methodsFor: 'tests cached serializer' stamp: 'MarianoMartinezPeck 1/5/2012 11:31'!
testExporterReset

	| aClass aClassName  anotherClass sharedPool  |
	
	aClass := self newClassOrTrait.
	aClass class compileSilently: 'foo ^ 42'.
	
	self swapOutClass: aClass.

	MARObjectGraphExporter reset.
	3 timesRepeat: [Smalltalk garbageCollect].
	
	self assert: aClass mareaIsProxy.
! !

!MARGeneralSwappingTest methodsFor: 'tests cached serializer' stamp: 'MarianoMartinezPeck 1/5/2012 11:31'!
testExporterResetAndFlushClassNameCache

	| aClass aClassName  anotherClass sharedPool  |
	
	aClass := self newClassOrTrait.
	aClass class compileSilently: 'foo ^ 42'.
	
	self swapOutClass: aClass.

	MARObjectGraphExporter reset.
	3 timesRepeat: [Smalltalk garbageCollect].
	Smalltalk flushClassNameCache.
	Smalltalk globals classAndTraitNames.
	
	self assert: aClass mareaIsProxy.
! !

!MARGeneralSwappingTest methodsFor: 'tests basic' stamp: 'MarianoMartinezPeck 1/5/2012 11:30'!
testFacadeObjectNotAnymoreNoIntersection
	"This tests that a graph is loaded back when the ROOT receives a message and when there is NO intersection probem, that is, there is no swapping of external graphs that refer to our facade objects. In addition, it tests that a facade object to which we have created a proxy, is garbage collected because nobody else point to it. "
	| a b proxiesCount |
	
	3 timesRepeat: [Smalltalk garbageCollect].
	proxiesCount := self regularObjectProxyClass instanceCount.
	
	a := ClassWith2Var new.
	b := ClassWith1Var new. 
	"Do not put a string or something like that because otherwise it is stored in the literals of the method and hence it is considered as a shared object"
	b var1: 6.
	a var1: (Point x: 4 y: 2).
	a var2: b.

	self swapOutAndClean: a.
	3 timesRepeat: [Smalltalk garbageCollect].
	
	"Now lets say that nobody else point to the facade object B"	
	self assert: self regularObjectProxyClass instanceCount equals: proxiesCount + 2.
	b := nil.
	3 timesRepeat: [Smalltalk garbageCollect].
	self assert: self regularObjectProxyClass instanceCount equals: proxiesCount + 1.
	
	self swapIn: a.
	3 timesRepeat: [Smalltalk garbageCollect].
	self assert: self regularObjectProxyClass instanceCount equals: proxiesCount.
	self assert: a var2 var1 equals: 6.
	self assert: a var1 equals: 4@2.
	! !

!MARGeneralSwappingTest methodsFor: 'tests error' stamp: 'MarianoMartinezPeck 2/5/2012 12:16'!
testFileIsRemovedWhenError

	| anObject graphID |

	anObject := ClassWith1Var new.
	self swapOut: anObject.
	graphID :=  anObject mareaGraphID.

	anObject := OrderedCollection new.
	131073 timesRepeat:  [anObject add: ClassWith1Var new].
	self should: [self swapOut: anObject] raise: MARPositionBiggerThanMax.
	self deny: (FileDirectory default fileExists: (graphID + 1) asString , '.swap').
! !

!MARGeneralSwappingTest methodsFor: 'tests global state cleaning' stamp: 'MarianoMartinezPeck 2/5/2012 20:46'!
testGlobalTableCleaningForcingSharedProxiesCleaning

	| a b proxiesCount c |
	
	3 timesRepeat: [Smalltalk garbageCollect].

	a := ClassWith1Var new.
	b := (Point x: 4 y: 2).
	c := ClassWith1Var new. 
	c var1: b.
	a var1: b.

	self assert: MARObjectGraphSwapper globalSharedProxiesTable size equals: 0.
	self assert: MARObjectGraphSwapper globalGraphTable size equals: 0.
	
	self swapOut: a.
	self swapOut: c.
	
	self assert: MARObjectGraphSwapper globalSharedProxiesTable size equals: 1.
	self assert: MARObjectGraphSwapper globalGraphTable size equals: 2.
	self assert: (MARObjectGraphSwapper proxiesOfglobalGraphTableAt: 1) size equals: 2.
	self assert: (MARObjectGraphSwapper proxiesOfglobalGraphTableAt: 2) size equals: 2.


	"Lets clean the pointers from the test"
	b := nil.
	3 timesRepeat: [Smalltalk garbageCollect].

	self swapIn: c.
	self swapIn: c var1.

	MARObjectGraphSwapper clean. 
	3 timesRepeat: [Smalltalk garbageCollect].
	
	self assert: MARObjectGraphSwapper globalSharedProxiesTable size equals: 0.
	self assert: MARObjectGraphSwapper globalGraphTable size equals: 0.! !

!MARGeneralSwappingTest methodsFor: 'tests global state cleaning' stamp: 'MarianoMartinezPeck 2/5/2012 22:04'!
testGlobalTableCleaningForcingSharedProxiesCleaningAndOnlyRemoveSome

	| a b proxiesCount c d e |
	
	3 timesRepeat: [Smalltalk garbageCollect].

	a := ClassWith1Var new.
	b := (Point x: 4 y: 2).
	c := ClassWith1Var new. 
	c var1: b.
	a var1: b.


	self assert: MARObjectGraphSwapper globalSharedProxiesTable size equals: 0.
	self assert: MARObjectGraphSwapper globalGraphTable size equals: 0.
	
	self swapOut: a.
	self swapOut: c.

	self assert: MARObjectGraphSwapper globalSharedProxiesTable size equals: 1.
	self assert: MARObjectGraphSwapper globalGraphTable size equals: 2.
	self assert: (MARObjectGraphSwapper proxiesOfglobalGraphTableAt: 1) size equals: 2.
	self assert: (MARObjectGraphSwapper proxiesOfglobalGraphTableAt: 2) size equals: 2.


	"Lets clean the pointers from the test"
	b := nil.
	3 timesRepeat: [Smalltalk garbageCollect].

	self swapIn: c.

	MARObjectGraphSwapper clean. 
	3 timesRepeat: [Smalltalk garbageCollect].
	
	self assert: MARObjectGraphSwapper globalSharedProxiesTable size equals: 1.
	self assert: MARObjectGraphSwapper globalGraphTable size equals: 1.
	
	self swapIn: c var1.
	
	MARObjectGraphSwapper clean. 
	3 timesRepeat: [Smalltalk garbageCollect].
	
	self assert: MARObjectGraphSwapper globalSharedProxiesTable size equals: 0.
	self assert: MARObjectGraphSwapper globalGraphTable size equals: 0.
	! !

!MARGeneralSwappingTest methodsFor: 'tests global state cleaning' stamp: 'MarianoMartinezPeck 2/5/2012 21:03'!
testGlobalTablesCleaning

	| a b proxiesCount c |
	
	3 timesRepeat: [Smalltalk garbageCollect].

	a := ClassWith1Var new.
	b := (Point x: 4 y: 2).
	c := ClassWith1Var new. 
	c var1: b.
	a var1: b.

	self assert: MARObjectGraphSwapper globalSharedProxiesTable size equals: 0.
	self assert: MARObjectGraphSwapper globalGraphTable size equals: 0.
	
	self swapOut: a.
	self swapOut: c.
	
	self assert: MARObjectGraphSwapper globalSharedProxiesTable size equals: 1.
	self assert: MARObjectGraphSwapper globalGraphTable size equals: 2.
	self assert: (MARObjectGraphSwapper proxiesOfglobalGraphTableAt: 1) size equals: 2.
	self assert: (MARObjectGraphSwapper proxiesOfglobalGraphTableAt: 2) size equals: 2.


	"Lets clean the pointers from the test"
	b := nil.
	3 timesRepeat: [Smalltalk garbageCollect].

	self swapIn: c.
	self swapIn: c var1.
	
	3 timesRepeat: [Smalltalk garbageCollect].
	
	self assert: MARObjectGraphSwapper globalSharedProxiesTable size equals: 1.
	self assert: MARObjectGraphSwapper globalGraphTable size equals: 0.! !

!MARGeneralSwappingTest methodsFor: 'tests hash' stamp: 'MarianoMartinezPeck 1/5/2012 11:31'!
testIdentityHashIsPreserved
	
	| a originalHash |
	
	a := ClassWith2Var new.
	a var1: 'foo'.
	originalHash := a identityHash. 

	self swapOut: a.	
	self assert: a identityHash = originalHash.! !

!MARGeneralSwappingTest methodsFor: 'tests hash' stamp: 'MarianoMartinezPeck 1/5/2012 11:31'!
testIdentityHashIsPreservedInIdentitySet
	
	| a originalHash set |
	
	set := IdentitySet new.
	a := ClassWith2Var new.
	a var1: 'foo'.
	originalHash := a identityHash. 
	set add:  a.
	set add: 'mariano'.
	set add: 42.
	
	self swapOut: a.	
	set add:  a.
	set add:  a.	
	self assert: set size = 3.
	self assert: a identityHash = originalHash.! !

!MARGeneralSwappingTest methodsFor: 'tests enumeration' stamp: 'MarianoMartinezPeck 1/13/2012 12:41'!
testInstanceCount

	| a b proxiesCount objectsCount |
	3 timesRepeat: [ Smalltalk garbageCollect ].
	proxiesCount := self regularObjectProxyClass instanceCount.
	a := ClassWith2Var new.
	objectsCount := ClassWith2Var instanceCount.
		
	self swapOut: a.
	3 timesRepeat: [ Smalltalk garbageCollect ].	
	self assert: self regularObjectProxyClass instanceCount equals: proxiesCount + 1.
	self assert: ClassWith2Var instanceCount equals: objectsCount - 1.
	self assert: a mareaIsProxy.
	
	self swapIn: a.
	3 timesRepeat: [ Smalltalk garbageCollect ].	
	self assert: self regularObjectProxyClass instanceCount equals: proxiesCount.
	self assert: ClassWith2Var instanceCount equals: objectsCount.
	
	! !

!MARGeneralSwappingTest methodsFor: 'tests intersection' stamp: 'MarianoMartinezPeck 2/5/2012 21:04'!
testIntersectionOutAOutCInAInC
	"This tests the following scenario: Both, object AAA and CCC, point to BBB. 
	- AAA is swapped out first.
	- CCC is swapped out.
	- AAA is swapped in.
	- CCC is swapped in"
	| a b proxiesCount c |
	
	3 timesRepeat: [Smalltalk garbageCollect].
	proxiesCount := self regularObjectProxyClass instanceCount.
	
	a := ClassWith1Var new.
	b := (Point x: 4 y: 2).
	c := ClassWith1Var new. 
	c var1: b.
	a var1: b.

	self assert: MARObjectGraphSwapper globalSharedProxiesTable size equals: 0.
	self assert: MARObjectGraphSwapper globalGraphTable size equals: 0.
	
	self swapOut: a.

	3 timesRepeat: [Smalltalk garbageCollect].
	
	self assert: MARObjectGraphSwapper globalSharedProxiesTable size equals: 0.
	self assert: MARObjectGraphSwapper globalGraphTable size equals: 1.
	self assert: (MARObjectGraphSwapper proxiesOfglobalGraphTableAt: 1) size equals: 2.
		
	"There should be a proxy for A and B"	
	self assert: self regularObjectProxyClass instanceCount equals: proxiesCount + 2.
	self assert: b mareaIsProxy.
	self assert: a mareaIsProxy.
		
	"Now we swap another graph, C, which has intersection with A"
	self swapOut: c.
	self assert: MARObjectGraphSwapper globalSharedProxiesTable size equals: 1.
	self assert: MARObjectGraphSwapper globalGraphTable size equals: 2.
	self assert: (MARObjectGraphSwapper proxiesOfglobalGraphTableAt: 1) size equals: 2.
	self assert: (MARObjectGraphSwapper proxiesOfglobalGraphTableAt: 2) size equals: 2.
		

	"We have to be sure that when finding a proxy in the graph to serialize, we do not uninstall it"	
	self assert: b mareaIsProxy.
	self assert: c mareaIsProxy.


	"Lets clean the pointers from the test"
	b := nil.
	3 timesRepeat: [Smalltalk garbageCollect].

	
	self swapIn: a.
	3 timesRepeat: [Smalltalk garbageCollect].
	self assert: a var1 equals: (Point x: 4 y: 2).

	self swapIn: c.
	self deny: c mareaIsProxy.
	self deny: c var1 mareaIsProxy.
	self assert: c var1 == a var1.
! !

!MARGeneralSwappingTest methodsFor: 'tests intersection' stamp: 'MarianoMartinezPeck 2/5/2012 21:04'!
testIntersectionOutAOutCInCInA
	"This tests the following scenario: Both, object AAA and CCC, point to BBB. 
	- AAA is swapped out first.
	- CCC is swapped out.
	- CCC is swapped in
	- AAA is swapped in.
	It is important to notice in this case that when C is swapped in, B it is not. There will be a proxy there. B will only be replaced with the original object, only when the graph where it was serialized, is swapped in.
	"
	| a b proxiesCount c |
	
	3 timesRepeat: [Smalltalk garbageCollect].
	proxiesCount := self regularObjectProxyClass instanceCount.
	
	a := ClassWith1Var new.
	b := (Point x: 4 y: 2).
	c := ClassWith1Var new. 
	c var1: b.
	a var1: b.

	self assert: MARObjectGraphSwapper globalSharedProxiesTable size equals: 0.
	self assert: MARObjectGraphSwapper globalGraphTable size equals: 0.
	
	self swapOut: a.

	3 timesRepeat: [Smalltalk garbageCollect].
	
	self assert: MARObjectGraphSwapper globalSharedProxiesTable size equals: 0.
	self assert: MARObjectGraphSwapper globalGraphTable size equals: 1.
	self assert: (MARObjectGraphSwapper proxiesOfglobalGraphTableAt: 1) size equals: 2.
		
	"There should be a proxy for A and B"	
	self assert: self regularObjectProxyClass instanceCount equals: proxiesCount + 2.
	self assert: b mareaIsProxy.
	self assert: a mareaIsProxy.
		
	"Now we swap another graph, C, which has intersection with A"
	self swapOut: c.
	self assert: MARObjectGraphSwapper globalSharedProxiesTable size equals: 1.
	self assert: MARObjectGraphSwapper globalGraphTable size equals: 2.
	self assert: (MARObjectGraphSwapper proxiesOfglobalGraphTableAt: 1) size equals: 2.
	self assert: (MARObjectGraphSwapper proxiesOfglobalGraphTableAt: 2) size equals: 2.
		

	"We have to be sure that when finding a proxy in the graph to serialize, we do not uninstall it"	
	self assert: b mareaIsProxy.
	self assert: c mareaIsProxy.


	"Lets clean the pointers from the test"
	b := nil.
	3 timesRepeat: [Smalltalk garbageCollect].

	self swapIn: c.
	self deny: c mareaIsProxy.
	self assert: c var1 mareaIsProxy.

	self swapIn: a.
	3 timesRepeat: [Smalltalk garbageCollect].
	self assert: a var1 equals: (Point x: 4 y: 2).
	self deny: c var1 mareaIsProxy.
	self assert: c var1 == a var1.! !

!MARGeneralSwappingTest methodsFor: 'tests intersection' stamp: 'MarianoMartinezPeck 2/5/2012 21:04'!
testIntersectionOutAOutCInCInB
	"This tests the following scenario: Both, object AAA and CCC, point to BBB. 
	- AAA is swapped out first.
	- CCC is swapped out.
	- CCC is swapped in.
	- BBB is swapped in
	It is important to notice in this case that when C is swapped in, B it is not. There will be a proxy there. B will only be replaced with the original object, only when the graph where it was serialized, is swapped in.
	"
	| a b proxiesCount c |
	
	3 timesRepeat: [Smalltalk garbageCollect].
	proxiesCount := self regularObjectProxyClass instanceCount.
	
	a := ClassWith1Var new.
	b := (Point x: 4 y: 2).
	c := ClassWith1Var new. 
	c var1: b.
	a var1: b.

	self assert: MARObjectGraphSwapper globalSharedProxiesTable size equals: 0.
	self assert: MARObjectGraphSwapper globalGraphTable size equals: 0.
	
	self swapOut: a.

	3 timesRepeat: [Smalltalk garbageCollect].
	
	self assert: MARObjectGraphSwapper globalSharedProxiesTable size equals: 0.
	self assert: MARObjectGraphSwapper globalGraphTable size equals: 1.
	self assert: (MARObjectGraphSwapper proxiesOfglobalGraphTableAt: 1) size equals: 2.
		
	"There should be a proxy for A and B"	
	self assert: self regularObjectProxyClass instanceCount equals: proxiesCount + 2.
	self assert: b mareaIsProxy.
	self assert: a mareaIsProxy.
		
	"Now we swap another graph, C, which has intersection with A"
	self swapOut: c.
	self assert: MARObjectGraphSwapper globalSharedProxiesTable size equals: 1.
	self assert: MARObjectGraphSwapper globalGraphTable size equals: 2.
	self assert: (MARObjectGraphSwapper proxiesOfglobalGraphTableAt: 1) size equals: 2.
	self assert: (MARObjectGraphSwapper proxiesOfglobalGraphTableAt: 2) size equals: 2.
		

	"We have to be sure that when finding a proxy in the graph to serialize, we do not uninstall it"	
	self assert: b mareaIsProxy.
	self assert: c mareaIsProxy.


	"Lets clean the pointers from the test"
	b := nil.
	3 timesRepeat: [Smalltalk garbageCollect].

	self swapIn: c.
	self deny: c mareaIsProxy.
	self assert: c var1 mareaIsProxy.

	self swapIn: c var1.
	3 timesRepeat: [Smalltalk garbageCollect].
	self deny: c var1 mareaIsProxy.
	self assert: a var1 equals: (Point x: 4 y: 2).
	self assert: c var1 == a var1.! !

!MARGeneralSwappingTest methodsFor: 'tests global state cleaning' stamp: 'MarianoMartinezPeck 1/9/2012 15:10'!
testNotBecomedObjectsTableCleaning
	| object shared association object2 graphID graphID1 graphID2 key |
	object := OrderedCollection new.
	object2 := OrderedCollection new.
	shared := ClassWith1Var new.
	shared var1: 'mariano'.
	"Association is one of the type of objects that cannot be swapped so far. See #shouldCreateProxyFor:"
	association := (Association key: 42 value: shared).
	object add: association.
	object2 add: association.
	
	self swapOut: object.
	self swapOut: object2.

	graphID1 := object mareaGraphID.
	graphID2 := object2 mareaGraphID.

	self assert: object mareaIsProxy.
	self assert: object2 mareaIsProxy.

	self assert: (MARObjectGraphSwapper globalNotBecomedObjects keys select: [:each | (each class = Association) and: [each key = 42] ]) size = 1.
	key := (MARObjectGraphSwapper globalNotBecomedObjects keys select: [:each | (each class = Association) and: [each key = 42] ]) first.
	self assert:  ((MARObjectGraphSwapper globalNotBecomedObjects at: key) select: [:each | each mareaGraphID = graphID1 ]) size = 1. 
	self assert:  ((MARObjectGraphSwapper globalNotBecomedObjects at: key) select: [:each | each mareaGraphID = graphID2 ]) size = 1. 
	
	self swapIn: object.
	
	self assert: (MARObjectGraphSwapper globalNotBecomedObjects keys select: [:each | (each class = Association) and: [each key = 42] ]) size = 1.
	key := (MARObjectGraphSwapper globalNotBecomedObjects keys select: [:each | (each class = Association) and: [each key = 42] ]) first.
	self assert:  ((MARObjectGraphSwapper globalNotBecomedObjects at: key) select: [:each | each mareaGraphID = graphID1 ]) size = 0. 
	self assert:  ((MARObjectGraphSwapper globalNotBecomedObjects at: key) select: [:each | each mareaGraphID = graphID2 ]) size = 1. 

	self swapIn: object2.

	self assert: (MARObjectGraphSwapper globalNotBecomedObjects keys select: [:each | (each class = Association) and: [each key = 42] ]) size = 0.
	
	self assert: object first  = object2 first.
	self assert: object first  == object2 first. ! !

!MARGeneralSwappingTest methodsFor: 'tests not proxified objects' stamp: 'MarianoMartinezPeck 1/6/2012 11:01'!
testObjectCannotBeProxified
	| object shared association |
	object := OrderedCollection new.
	shared := ClassWith1Var new.
	shared var1: 'mariano'.
	"Association is one of the type of objects that cannot be swapped so far. See #shouldCreateProxyFor:"
	association := (Association key: 42 value: shared).
	object add: association.
	
	self swapOut: object.
	self assert: object mareaIsProxy.
	
	self swapIn: object.
	self assert: object first  == association.! !

!MARGeneralSwappingTest methodsFor: 'tests not proxified objects' stamp: 'MarianoMartinezPeck 1/9/2012 12:02'!
testObjectCannotBeProxifiedAndSharedByTwoGraphs
	| object shared association object2 |
	object := OrderedCollection new.
	object2 := OrderedCollection new.
	shared := ClassWith1Var new.
	shared var1: 'mariano'.
	"Association is one of the type of objects that cannot be swapped so far. See #shouldCreateProxyFor:"
	association := (Association key: 42 value: shared).
	object add: association.
	object2 add: association.
	
	self swapOut: object.
	self swapOut: object2.

	self assert: object mareaIsProxy.
	self assert: object2 mareaIsProxy.
	
	association := nil.
	3 timesRepeat: [Smalltalk garbageCollect].
	
	self swapIn: object.
	self swapIn: object2.
	self assert: object first  = object2 first.
	self assert: object first  == object2 first.! !

!MARGeneralSwappingTest methodsFor: 'tests basic' stamp: 'MarianoMartinezPeck 1/5/2012 11:30'!
testRootObjectNotAnymoreNoIntersection
	"This tests that a graph is loaded back when a facade object receives a message and when there is NO intersection probem, that is, there is no swapping of external graphs that refer to our facade objects. In addition, it tests that the root object to which we have created a proxy, is garbage collected because nobody else point to it. "
	| a b proxiesCount |
	
	3 timesRepeat: [Smalltalk garbageCollect].
	proxiesCount := self regularObjectProxyClass instanceCount.
	
	a := ClassWith2Var new.
	b := ClassWith1Var new. 
	"Do not put a string or something like that because otherwise it is stored in the literals of the method and hence it is considered as a shared object"
	b var1: 6.
	a var1: (Point x: 4 y: 2).
	a var2: b.

	self swapOutAndClean: a.
	3 timesRepeat: [Smalltalk garbageCollect].
	
	"Now lets say that nobody else point to the root object A"	
	self assert: self regularObjectProxyClass instanceCount equals: proxiesCount + 2.
	a := nil.
	3 timesRepeat: [Smalltalk garbageCollect].
	self assert: self regularObjectProxyClass instanceCount equals: proxiesCount + 1.
	
	self swapIn: b.
	3 timesRepeat: [Smalltalk garbageCollect].
	self assert: self regularObjectProxyClass instanceCount equals: proxiesCount.
	self assert: b var1 equals: 6.
! !

!MARGeneralSwappingTest methodsFor: 'tests pending' stamp: 'MarianoMartinezPeck 1/5/2012 11:31'!
testSomethingOptimizedByFuel! !

!MARGeneralSwappingTest methodsFor: 'tests pending' stamp: 'MarianoMartinezPeck 1/5/2012 11:31'!
testSomethingWithNilsInside! !

!MARGeneralSwappingTest methodsFor: 'tests error' stamp: 'MarianoMartinezPeck 2/1/2012 09:46'!
testSwapInWithNotAProxy

	| anObject |

	anObject := ClassWith1Var new.
	self swapOut: anObject.
	self swapIn: anObject.
	self shouldnt: [MARObjectGraphImporter new swapInGraphFor: anObject. ] raise: MARObjectIsNotProxy! !

!MARGeneralSwappingTest methodsFor: 'tests basic' stamp: 'MarianoMartinezPeck 1/5/2012 11:30'!
testUninstallFromRootNoIntersection
	"This tests that a graph is loaded back when the ROOT receives a message and when there is NO intersection probem, that is, there is no swapping of external graphs that refer to our facade objects."
	| a b proxiesCount |
	
	3 timesRepeat: [Smalltalk garbageCollect].
	proxiesCount := self regularObjectProxyClass instanceCount.
	
	a := ClassWith2Var new.
	b := ClassWith1Var new. 
	"Do not put a string or something like that because otherwise it is stored in the literals of the method and hence it is considered as a shared object"
	b var1: 6.
	a var1: (Point x: 4 y: 2).
	a var2: b.
	
	self swapOut: a.
	3 timesRepeat: [Smalltalk garbageCollect].
	self swapIn: a.
	3 timesRepeat: [Smalltalk garbageCollect].
	self assert: self regularObjectProxyClass instanceCount equals: proxiesCount.
	self assert: b == a var2.
	self assert: b var1 equals: 6.
	self assert: a var1 equals: 4@2.
	! !

!MARGeneralSwappingTest methodsFor: 'tests basic' stamp: 'MarianoMartinezPeck 1/5/2012 11:30'!
testUninstallFromSharedObjectNoIntersection
	"This tests that a graph is loaded back when a facade object receives a message and when there is NO intersection probem, that is, there is no swapping of external graphs that refer to our facade objects."
	| a b proxiesCount |
	
	3 timesRepeat: [Smalltalk garbageCollect].
	proxiesCount := self regularObjectProxyClass instanceCount.
	
	a := ClassWith2Var new.
	b := ClassWith1Var new. 
	"Do not put a string or something like that because otherwise it is stored in the literals of the method and hence it is considered as a shared object"
	b var1: 6.
	a var1: (Point x: 4 y: 2).
	a var2: b.

	self swapOut: a.
	3 timesRepeat: [Smalltalk garbageCollect].
	self swapIn: b.
	3 timesRepeat: [Smalltalk garbageCollect].
	self assert: self regularObjectProxyClass instanceCount equals: proxiesCount.
	self assert: b == a var2.
	self assert: b var1 equals: 6.
	self assert: a var1 equals: 4@2.! !

!MARGeneralSwappingTest methodsFor: 'tests enumeration' stamp: 'MarianoMartinezPeck 1/10/2012 12:02'!
testUninstallIfNeededAllInstances
	
	| a  proxiesCount b |
	
	3 timesRepeat: [Smalltalk garbageCollect].
	proxiesCount := self regularObjectProxyClass instanceCount.
	
	a := ClassWith2Var new.
	a var1: 'foo'.
	self swapOut: a.	

	b := ClassWith2Var new.
	b var1: 'foo2'.
	self swapOut: b.	

	self assert: a mareaIsProxy.
	self assert: b mareaIsProxy.
	
	self regularObjectProxyClass mareaUninstallIfNeededAllInstances.
	
	self deny: a mareaIsProxy.
	self deny: b mareaIsProxy.
	
	3 timesRepeat: [Smalltalk garbageCollect].
	self assert: proxiesCount = self regularObjectProxyClass instanceCount.
! !

!MARGeneralSwappingTest methodsFor: 'tests pending' stamp: 'MarianoMartinezPeck 1/5/2012 11:31'!
xtestRootObjectNotAnymoreNoIntersection2
	"This tests that a graph is loaded back when a facade object receives a message and when there is NO intersection probem, that is, there is no swapping of external graphs that refer to our facade objects. In addition, it tests that the root object to which we have created a proxy, is garbage collected because nobody else point to it. "
	| a b proxiesCount |
	
	3 timesRepeat: [Smalltalk garbageCollect].
	proxiesCount := MARRegularObjectProxyMock instanceCount.
	
	a := ClassWith2Var new.
	b := ClassWith1Var new. 
	b var1: 'nose'.
	a var1: Date today.
	a var2: b.

	MARObjectGraphExporter new swapOutGraph: a.
	3 timesRepeat: [Smalltalk garbageCollect].
	
	"Now lets say that nobody else point to the root object A"	
	self assert: MARRegularObjectProxyMock instanceCount equals: proxiesCount + 2.
	a := nil.
	3 timesRepeat: [Smalltalk garbageCollect].
	self assert: MARRegularObjectProxyMock instanceCount equals: proxiesCount + 1.
	
	MARObjectGraphExporter new swapInGraphFor: b.
	3 timesRepeat: [Smalltalk garbageCollect].
	self assert: MARRegularObjectProxyMock instanceCount equals: proxiesCount.
	self assert: b var1 equals: 'nose'.
! !

MARBaseObjectGraphSwapperTest subclass: #MARHelperTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MareaTests-Swapping'!

!MARHelperTest methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 1/12/2012 12:23'!
tearDown
	MARBaseObjectGraphSwapperTest compileAll.
	self classFactory cleanUp.
	MARObjectGraphExporter reset.
"	3 timesRepeat: [Smalltalk garbageCollect].
	MARRegularObjectProxy mareaUninstallIfNeededAllInstances.
	MARClassProxy mareaUninstallIfNeededAllInstances."! !

!MARHelperTest methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 2/5/2012 19:26'!
testSwapOutClass
	|  aClassCopy instance objectsToSwap |

	"3 timesRepeat: [Smalltalk garbageCollect].
		MARLogger changeToTranscriptLogger.
	 self swapOutClassWithInstances:  MCPackage.
	 self swapOutClassWithInstances:  MCPackageManager.
	self swapIn: MCPackageManager.
	
"! !

MARBaseObjectGraphSwapperTest subclass: #MARMethodSwappingTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MareaTests-Swapping'!

!MARMethodSwappingTest methodsFor: 'tests method swapping' stamp: 'MarianoMartinezPeck 1/5/2012 11:28'!
testCompiledMethodIdentity

	| aClass object method |

	object := OrderedCollection new.
	aClass := self newClassWithInstanceVariableNames: 'foo bar'.
	aClass compileSilently: 'foo ^ foo'.
	method := aClass compiledMethodAt: #foo.
	object add: method.
	
	self swapOut: object.
	self assert: method mareaIsProxy.
	self assert: object mareaIsProxy.
	self swapIn: object.
	self assert: (aClass compiledMethodAt: #foo) == object first.
	
	! !

!MARMethodSwappingTest methodsFor: 'tests method swapping' stamp: 'MarianoMartinezPeck 1/5/2012 11:28'!
testCompiledMethodsAreRebindSwapInByClass

	| aClass method anotherClass |

	aClass := self newClassWithInstanceVariableNames: ''.
	
	anotherClass := self newClassWithInstanceVariableNames: ''.
	anotherClass compileSilently: 'foo ^ ', aClass name asString , ' name'.
	method := anotherClass compiledMethodAt: #foo.
	
	self assert: (method literalAt: 2) == (Smalltalk globals associationAt: aClass name).
	
	self swapOutClass: aClass.
	self swapOutClass: anotherClass.
	self swapIn: anotherClass.
	
	self assert: aClass mareaIsProxy.
	self deny: anotherClass mareaIsProxy.
	
	
	self assert: (method literalAt: 2) == (Smalltalk globals associationAt: aClass name).
	! !

!MARMethodSwappingTest methodsFor: 'tests method swapping' stamp: 'MarianoMartinezPeck 1/5/2012 11:28'!
testCompiledMethodsAreRebindSwapInByInstance

	| aClass method anotherClass anotherClassInstance |

	aClass := self newClassWithInstanceVariableNames: ''.
	
	anotherClass := self newClassWithInstanceVariableNames: ''.
	anotherClass compileSilently: 'foo ^ ', aClass name asString , ' name'.
	anotherClassInstance := anotherClass new. 
	method := anotherClass compiledMethodAt: #foo.
	
	
	self assert: (method literalAt: 2) == (Smalltalk globals associationAt: aClass name).
	
	self swapOutClass: anotherClass.
	self swapIn: anotherClassInstance.
	
	self assert: (method literalAt: 2) == (Smalltalk globals associationAt: aClass name).
	! !

!MARMethodSwappingTest methodsFor: 'tests method swapping' stamp: 'MarianoMartinezPeck 1/5/2012 11:28'!
testCompiledMethodsAreRebindSwapInBySubclass

	| aClass method anotherClass anotherClassInstance anotherClassSubclass |

	aClass := self newClassWithInstanceVariableNames: ''.
	
	anotherClass := self newClassWithInstanceVariableNames: ''.
	anotherClass compileSilently: 'foo ^ ', aClass name asString , ' name'.
	anotherClassInstance := anotherClass new. 
	method := anotherClass compiledMethodAt: #foo.
	
	anotherClassSubclass := self newClassWithInstanceVariableNames: '' superclass: anotherClass.
		
	self assert: (method literalAt: 2) == (Smalltalk globals associationAt: aClass name).
	
	self swapOutClass: anotherClass.
	self swapIn: anotherClassSubclass.
	
	self assert: (method literalAt: 2) == (Smalltalk globals associationAt: aClass name).
	! !

!MARMethodSwappingTest methodsFor: 'tests method swapping' stamp: 'MarianoMartinezPeck 1/5/2012 11:28'!
testSwapOutCompiledMethodsAndExecuteIt
	|  instance |

	instance := ClassWith1Var new. 
	MARObjectGraphExporter new swapOutGraph: (ClassWith1Var>>#foo)..
	self assert: instance foo = 'foo' 
	! !

MARBaseObjectGraphSwapperTest subclass: #MARProxiesSwappingTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MareaTests-Swapping'!

!MARProxiesSwappingTest methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 2/3/2012 23:57'!
serializer
	^ MARFuelMareaSerializer ! !

!MARProxiesSwappingTest methodsFor: 'tests proxies' stamp: 'MarianoMartinezPeck 2/6/2012 19:34'!
testClassProxyCreation
	| aProxy  |
	
	aProxy := self classProxyClass newProxyWith: 131000 graphID: 55.
	self assert: aProxy mareaPosition = 131000.
	self assert: aProxy mareaGraphID = 55. ! !

!MARProxiesSwappingTest methodsFor: 'tests proxies' stamp: 'MarianoMartinezPeck 2/6/2012 19:35'!
testLargeClassProxyCreation
	| aProxy id |
	
	aProxy := MARClassProxyLarge newProxyWith: 131344000 graphID: 353454355.
	self assert: aProxy mareaPosition = 131344000.
	self assert: aProxy mareaGraphID = 353454355. 
	id := aProxy mareaProxyID.
	
	aProxy := MARClassProxyLarge new mareaProxyID: id.
	self assert: aProxy mareaPosition = 131344000.
	self assert: aProxy mareaGraphID = 353454355. 
	! !

!MARProxiesSwappingTest methodsFor: 'tests proxies' stamp: 'MarianoMartinezPeck 2/6/2012 19:32'!
testSerialiationOfClassProxy
	| aProxy materializedProxy |
	"This method tests that an instance of a proxy can be serialized and materialized WITHOUT being uninstalled, that is, without receiving a message that should be intercepted. "
	
	aProxy := self classProxyClass newProxyWith: 42 graphID: 24.
	"Even we have serialized the proxy, it should continue to be a proxy and it should raise error"
	self serializer serialize: aProxy toFileNamed: 'testSerialiationOfClassProxy.swap'.
	materializedProxy := self serializer materializedObjectFromFileNamed: 'testSerialiationOfClassProxy.swap'.
	self assert: materializedProxy mareaPosition equals: 42.
	self assert: materializedProxy mareaGraphID equals: 24.
	self assert: materializedProxy mareaClass = self classProxyClass.
	self assert: materializedProxy mareaIsWellInitialized.! !

!MARProxiesSwappingTest methodsFor: 'tests proxies' stamp: 'MarianoMartinezPeck 2/6/2012 19:32'!
testSerialiationOfClassProxyInsideAGraph
	| aProxy materializedObject anObject |
	"This method tests that an instance of a proxy can be serialized and materialized  inside a graph WITHOUT being uninstalled, that is, without receiving a message that should be intercepted. "
	
	aProxy := self classProxyClass newProxyWith: 42 graphID: 24.
	anObject := ClassWith2Var new.
	anObject var1: aProxy.
	anObject var2:  'mariano'.
	
	"Even we have serialized the proxy, it should continue to be a proxy and it should raise error"
	self serializer serialize: anObject toFileNamed: 'testSerialiationOfProxyInsideAGraph.swap'.
	materializedObject := self serializer materializedObjectFromFileNamed: 'testSerialiationOfProxyInsideAGraph.swap'.
	self assert: materializedObject var2 equals: 'mariano'.	
	self assert: materializedObject var1 mareaPosition equals: 42.
	self assert: materializedObject var1 mareaGraphID equals: 24.
	self assert: materializedObject var1 mareaClass = self classProxyClass.
	self assert: materializedObject var1 mareaIsWellInitialized.
	! !

!MARProxiesSwappingTest methodsFor: 'tests proxies' stamp: 'MarianoMartinezPeck 2/6/2012 19:32'!
testSerialiationOfProxy
	| aProxy materializedProxy |
	"This method tests that an instance of a proxy can be serialized and materialized WITHOUT being uninstalled, that is, without receiving a message that should be intercepted. "
	
	aProxy := self regularObjectProxyClass newProxyWith: 42 graphID: 24.
	"Even we have serialized the proxy, it should continue to be a proxy and it should raise error"
	self serializer serialize: aProxy toFileNamed: 'testSerialiationOfProxy.swap'.
	materializedProxy := self serializer materializedObjectFromFileNamed: 'testSerialiationOfProxy.swap'.
	self assert: materializedProxy mareaPosition equals: 42.
	self assert: materializedProxy mareaGraphID equals: 24.
	self assert: materializedProxy mareaClass = self regularObjectProxyClass.! !

!MARProxiesSwappingTest methodsFor: 'tests proxies' stamp: 'MarianoMartinezPeck 2/6/2012 19:33'!
testSerialiationOfProxyInsideAGraph
	| aProxy materializedObject anObject |
	"This method tests that an instance of a proxy can be serialized and materialized  inside a graph WITHOUT being uninstalled, that is, without receiving a message that should be intercepted. "
	
	aProxy := self regularObjectProxyClass newProxyWith: 42 graphID: 24.
	anObject := ClassWith2Var new.
	anObject var1: aProxy.
	anObject var2:  'mariano'.
	
	"Even we have serialized the proxy, it should continue to be a proxy and it should raise error"
	self serializer serialize: anObject toFileNamed: 'testSerialiationOfProxyInsideAGraph.swap'.
	materializedObject := self serializer materializedObjectFromFileNamed: 'testSerialiationOfProxyInsideAGraph.swap'.
	self assert: materializedObject var2 equals: 'mariano'.	
	self assert: materializedObject var1 mareaPosition equals: 42.
	self assert: materializedObject var1 mareaGraphID equals: 24.
	self assert: materializedObject var1 mareaClass = self regularObjectProxyClass.
	! !

!MARProxiesSwappingTest methodsFor: 'tests proxies' stamp: 'MarianoMartinezPeck 2/6/2012 19:33'!
testSerialiationOfProxyInsideAnArray
	| aProxy materializedObject anObject |
	"This method tests that an instance of a proxy can be serialized and materialized  inside an array  WITHOUT being uninstalled, that is, without receiving a message that should be intercepted. "
	
	aProxy := self regularObjectProxyClass newProxyWith: 42 graphID: 24.
	anObject := Array with: aProxy.
	
	"Even we have serialized the proxy, it should continue to be a proxy and it should raise error"
	self serializer serialize: anObject toFileNamed: 'testSerialiationOfProxyInsideAnArray.swap'.
	materializedObject := self serializer materializedObjectFromFileNamed: 'testSerialiationOfProxyInsideAnArray.swap'.
	self assert: materializedObject first mareaPosition equals: 42.
	self assert: materializedObject first mareaGraphID equals: 24.
	self assert: materializedObject first mareaClass = self regularObjectProxyClass.
	
	! !

MARBaseObjectGraphSwapperTest subclass: #MARSharedPoolsSwappingTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MareaTests-Swapping'!

!MARSharedPoolsSwappingTest methodsFor: 'tests sharedPools' stamp: 'MarianoMartinezPeck 1/5/2012 11:29'!
testOutClassOutSharedPoolInSharedPoolInClass

	| aClass aClassName  anotherClass sharedPool  |
	
	sharedPool := self newClassOrTraitWithSuperClass: SharedPool.
	sharedPool addClassVarNamed: 'ClassVar1'.
	sharedPool  class compile: 'classVar1: a  ClassVar1 := a. '.
	sharedPool  class compile: 'classVar1 ^  ClassVar1 '.
	
	aClass := self newClassOrTrait.
	aClass class compileSilently: 'foo ^ ClassVar1'.
	aClassName := aClass name asString.
	aClass addSharedPool: sharedPool.
	
	self swapOutClass: sharedPool.
	self swapOutClass: aClass.
	
	self assert: sharedPool mareaIsProxy.
	self assert: aClass mareaIsProxy.
	
	self swapIn: sharedPool.
	
	self deny: sharedPool mareaIsProxy.
	self assert: aClass mareaIsProxy.
	
	self swapIn: aClass.
	
	self deny: aClass mareaIsProxy.
	self assert: aClass sharedPools first == sharedPool.
	! !

!MARSharedPoolsSwappingTest methodsFor: 'tests sharedPools' stamp: 'MarianoMartinezPeck 1/5/2012 11:29'!
testOutSharedPoolOutClassInClass

	| aClass aClassName  anotherClass sharedPool  |
	
	sharedPool := self newClassOrTraitWithSuperClass: SharedPool.
	sharedPool addClassVarNamed: 'ClassVar1'.
	sharedPool  class compile: 'classVar1: a  ClassVar1 := a. '.
	sharedPool  class compile: 'classVar1 ^  ClassVar1 '.
	
	aClass := self newClassOrTrait.
	aClass class compileSilently: 'foo ^ ClassVar1'.
	aClassName := aClass name asString.
	aClass addSharedPool: sharedPool.
	
	self swapOutClass: sharedPool.
	self swapOutClass: aClass.
	
	self assert: sharedPool mareaIsProxy.
	self assert: aClass mareaIsProxy.
	
	self swapIn: aClass.
	
	self assert: aClass sharedPools first == sharedPool.
	self deny: sharedPool mareaIsProxy.
	self deny: aClass mareaIsProxy.
	
	self swapIn: sharedPool.
	self deny: sharedPool mareaIsProxy.
	self assert: aClass sharedPools first == sharedPool.
	! !

!MARSharedPoolsSwappingTest methodsFor: 'tests sharedPools' stamp: 'MarianoMartinezPeck 1/5/2012 11:29'!
testOutSharedPoolResetOutInClass

	| aClass aClassName  anotherClass sharedPool  |
	
	sharedPool := self newClassOrTraitWithSuperClass: SharedPool.
	sharedPool addClassVarNamed: 'ClassVar1'.
	sharedPool  class compile: 'classVar1: a  ClassVar1 := a. '.
	sharedPool  class compile: 'classVar1 ^  ClassVar1 '.
	
	aClass := self newClassOrTrait.
	aClass class compileSilently: 'foo ^ ClassVar1'.
	aClassName := aClass name asString.
	aClass addSharedPool: sharedPool.
	
	self swapOutClass: sharedPool.
	
	MARObjectGraphExporter reset.
	3 timesRepeat: [Smalltalk garbageCollect].
	
	self swapOutClass: aClass.
	
	self assert: sharedPool mareaIsProxy.
	self assert: aClass mareaIsProxy.
	"
	self swapIn: sharedPool.
	
	self deny: sharedPool mareaIsProxy.
	self assert: aClass mareaIsProxy.
	
	self swapIn: aClass.
	
	self deny: aClass mareaIsProxy.
	self assert: aClass sharedPools first == sharedPool."
	! !

!MARSharedPoolsSwappingTest methodsFor: 'tests sharedPools' stamp: 'MarianoMartinezPeck 1/5/2012 11:29'!
testSwapOutClassThatSwapInASwappedOne

	| aClass aClassName  anotherClass sharedPool  |
	
	"ZipEncoderTree"
	aClass := self newClassOrTrait.
	aClass class compileSilently: 'foo: something   ^ 42 + something'.
	aClassName := aClass name asString.
	
	"ZipConstants"
	sharedPool := self newClassOrTraitWithSuperClass: SharedPool.
	sharedPool addClassVarNamed: 'ClassVar1'.
	sharedPool  class compile: 'classVar1: a  ClassVar1 := a. '.
	sharedPool  class compile: 'classVar1 ^  ClassVar1 '.
	sharedPool addClassVarNamed: 'ClassVar2'.
	sharedPool  class compile: 'classVar2: a  ClassVar2 := a. '.
	sharedPool  class compile: 'classVar2 ^  ClassVar2 '.
	sharedPool perform: #classVar1: with: 1.
	sharedPool perform: #classVar2: with: aClass new.
	
	"ZipWriteStream"	
	anotherClass := self newClassOrTrait.
	anotherClass addSharedPool: sharedPool.
	anotherClass class compileSilently: 'bar ^ ', aClassName , ' foo: ', ' ClassVar1 '.

	self assert: (anotherClass perform: #bar) = 43. 
	self assert: (aClass perform: #foo: with: 2) = 44. 

	self swapOutClass: aClass.
	self swapOutClass: sharedPool.
	
	self assert: (anotherClass perform: #bar) = 43. 
	self assert: (aClass perform: #foo: with: 2) = 44. ! !

!MARSharedPoolsSwappingTest methodsFor: 'tests sharedPools' stamp: 'MarianoMartinezPeck 1/5/2012 11:29'!
testSwapOutClassThatSwapInASwappedOneAndCheckSharedPoolRefernece

	| aClass aClassName  anotherClass sharedPool association |
	
	"ZipEncoderTree"
	aClass := self newClassOrTrait.
	aClass class compileSilently: 'foo: something   ^ 42 + something'.
	aClassName := aClass name asString.
	
	"ZipConstants"
	sharedPool := self newClassOrTraitWithSuperClass: SharedPool.
	sharedPool addClassVarNamed: 'ClassVar1'.
	sharedPool  class compile: 'classVar1: a  ClassVar1 := a. '.
	sharedPool  class compile: 'classVar1 ^  ClassVar1 '.
	sharedPool addClassVarNamed: 'ClassVar2'.
	sharedPool  class compile: 'classVar2: a  ClassVar2 := a. '.
	sharedPool  class compile: 'classVar2 ^  ClassVar2 '.
	sharedPool perform: #classVar1: with: 1.
	sharedPool perform: #classVar2: with: aClass new.

	"ZipWriteStream"	
	anotherClass := self newClassOrTrait.
	anotherClass addSharedPool: sharedPool.
	anotherClass class compileSilently: 'bar ^ ', aClassName , ' foo: ', ' ClassVar1 '.

	self assert: ((anotherClass class methodDict at: #bar) literalAt: 2) == (Smalltalk globals associationAt: aClassName asSymbol).    
	association := (sharedPool classPool  associationAt: #ClassVar1).
	self assert: ((anotherClass class methodDict at: #bar) literalAt: 3) == association.  	
	self assert: (anotherClass perform: #bar) = 43. 
	self assert: (aClass perform: #foo: with: 2) = 44. 
	

	self swapOutClass: aClass.
	self swapOutClass: sharedPool.

	self assert: ((anotherClass class methodDict at: #bar) literalAt: 2) == (Smalltalk globals associationAt: aClassName asSymbol).    
 	self assert: ((anotherClass class methodDict at: #bar) literalAt: 3) == association.
	self assert: (anotherClass perform: #bar) = 43. 
	self assert: (aClass perform: #foo: with: 2) = 44. 	
! !

ByteArray variableByteSubclass: #MockClassCollection
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MareaTests-Mocks'!

ProtoObject subclass: #CompiledMethodProxyMock
	instanceVariableNames: 'oldMethod reference executed'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MareaTests-Mocks'!

!CompiledMethodProxyMock class methodsFor: 'instance creation' stamp: 'MarianoMartinezPeck 10/22/2010 11:40'!
installOn: aClass selector: aSel
	| newInst |
	newInst := (self on: aClass selector: aSel)  install.
	^ newInst! !

!CompiledMethodProxyMock class methodsFor: 'instance creation' stamp: 'MarianoMartinezPeck 10/22/2010 11:40'!
installOnClass: aClass
	|someWrappers|
	someWrappers:=OrderedCollection new.
	aClass selectors do: [:aSymbol | someWrappers add: (self installOn: aClass selector: aSymbol)].
	aClass class selectors do: [:aSymbol | someWrappers add: (self installOn: aClass class selector: aSymbol)].
	^someWrappers! !

!CompiledMethodProxyMock class methodsFor: 'instance creation' stamp: 'MarianoMartinezPeck 10/22/2010 11:40'!
installOnClassCategory: aString
	|someWrappers|
	someWrappers:= OrderedCollection new.
	(Smalltalk organization listAtCategoryNamed: aString) do: [:aClassName | 
		someWrappers addAll: (self installOnClass: (Smalltalk classNamed: aClassName)).
		].
	^someWrappers
	! !

!CompiledMethodProxyMock class methodsFor: 'instance creation' stamp: 'MarianoMartinezPeck 10/22/2010 11:40'!
on: aMethodReference
	^self new initializeFor: aMethodReference ! !

!CompiledMethodProxyMock class methodsFor: 'instance creation' stamp: 'MarianoMartinezPeck 10/22/2010 11:40'!
on: aClass selector: aSelector
	^self on: (MethodReference class: aClass selector: aSelector)! !

!CompiledMethodProxyMock class methodsFor: 'instance creation' stamp: 'MarianoMartinezPeck 10/22/2010 11:40'!
uninstallClass: aClass
	aClass methodDict values do: [:e | (e isKindOf: self) ifTrue: [e uninstall]].
	aClass class methodDict values do: [:e | (e isKindOf: self) ifTrue: [e uninstall]].! !

!CompiledMethodProxyMock class methodsFor: 'instance creation' stamp: 'MarianoMartinezPeck 10/22/2010 11:40'!
uninstallClassCategory: aString
	(Smalltalk organization listAtCategoryNamed: aString) do: [:aClassName | 
		self uninstallClass: (Smalltalk classNamed: aClassName)]! !

!CompiledMethodProxyMock class methodsFor: 'instance creation' stamp: 'MarianoMartinezPeck 10/22/2010 11:40'!
uninstallOnClassCategory: aString
	(Smalltalk organization listAtCategoryNamed: aString) do: [:aClassName | 
		self uninstallClass: (Smalltalk classNamed: aClassName)]! !

!CompiledMethodProxyMock methodsFor: 'testing' stamp: 'MarianoMartinezPeck 10/22/2010 17:25'!
doesNotUnderstand: aMessage
	self mareaLog: ' CompiledMethodProxy dnu: ', aMessage asString.
	^ oldMethod isNil
		ifTrue: [
			"It was not installed"
			super doesNotUnderstand: aMessage]
		ifFalse: [
			"It was installed, thus, I should uninstall it"
			self uninstall.
			oldMethod perform: aMessage selector withArguments: aMessage arguments.
			]! !

!CompiledMethodProxyMock methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 10/22/2010 11:40'!
executed
	^ executed! !

!CompiledMethodProxyMock methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 10/22/2010 11:40'!
executed: anObject
	executed := anObject! !

!CompiledMethodProxyMock methodsFor: 'action' stamp: 'MarianoMartinezPeck 5/2/2011 18:00'!
flushCache
	"This method should be implemented because otherwise there are errors."
	self selector flushCache! !

!CompiledMethodProxyMock methodsFor: 'initializing' stamp: 'MarianoMartinezPeck 10/22/2010 11:40'!
initialize

	super initialize.
	executed := false! !

!CompiledMethodProxyMock methodsFor: 'initializing' stamp: 'MarianoMartinezPeck 10/22/2010 11:40'!
initializeFor: aMethodReference 
	reference := aMethodReference.! !

!CompiledMethodProxyMock methodsFor: 'action' stamp: 'MarianoMartinezPeck 10/22/2010 17:25'!
install
	[oldMethod := self wrappedClass lookupSelector: self selector.
	oldMethod isKindOf: self class] whileTrue: [oldMethod uninstall].
	"self wrappedClass addSelector: self selector withMethod: self" 
	self mareaLog: 'The method ', self selector asString, ' is being wrapped'.
	self wrappedClass methodDict at: self selector put: self! !

!CompiledMethodProxyMock methodsFor: 'action' stamp: 'MarianoMartinezPeck 5/2/2011 17:57'!
mareaLog: aString
	Transcript show: aString asString; cr.! !

!CompiledMethodProxyMock methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 10/22/2010 11:40'!
oldMethod
	"Answer the value of oldMethod"

	^ oldMethod! !

!CompiledMethodProxyMock methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 10/22/2010 11:40'!
oldMethod: anObject
	"Set the value of oldMethod"

	oldMethod := anObject! !

!CompiledMethodProxyMock methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 10/22/2010 11:40'!
reference
	^ reference ! !

!CompiledMethodProxyMock methodsFor: 'action' stamp: 'MarianoMartinezPeck 10/22/2010 17:25'!
run: aSelector with: arguments in: aReceiver

	| aResult |
	self mareaLog: 'The method ', aSelector asString, ' is being executed'.
	aResult := oldMethod valueWithReceiver: aReceiver arguments: arguments.
	self executed: true.
	self mareaLog: 'The method', aSelector asString, ' was executed'.
	self uninstall.
	self mareaLog: 'The method proxy was uninstalled'.
	^aResult
	! !

!CompiledMethodProxyMock methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 10/22/2010 11:40'!
selector
	"Answer the value of selector"

	^ reference selector! !

!CompiledMethodProxyMock methodsFor: 'action' stamp: 'MarianoMartinezPeck 10/22/2010 11:40'!
uninstall
	oldMethod isNil ifTrue: [^self].
	self wrappedClass methodDict at: self selector put: oldMethod  

! !

!CompiledMethodProxyMock methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 10/22/2010 11:40'!
wrappedClass
	"Answer the value of wrappedClass"

	^ reference actualClass! !

Object subclass: #ClassWith2Var
	instanceVariableNames: 'var1 var2'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MareaTests-Mocks'!

!ClassWith2Var methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 10/16/2010 21:30'!
foo
	^ 'foo'! !

!ClassWith2Var methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 10/16/2010 21:30'!
var1
	^ var1! !

!ClassWith2Var methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 10/16/2010 21:30'!
var1: anObject
	var1 := anObject! !

!ClassWith2Var methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 10/16/2010 21:31'!
var2
	^ var2! !

!ClassWith2Var methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 10/16/2010 21:31'!
var2: anObject
	var2 := anObject! !

Object subclass: #ClassWithDNU
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MareaTests-Mocks'!

!ClassWithDNU methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 10/21/2010 16:02'!
doesNotUnderstand: aMessage
	^ 'dnu'! !

Object subclass: #CompactClassMock
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MareaTests-Mocks'!

!CompactClassMock class methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 3/21/2011 15:39'!
fooClass
	^ 'fooClass'! !

!CompactClassMock class methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 3/21/2011 15:37'!
initialize 
	self becomeCompact ! !

!CompactClassMock methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 3/21/2011 15:40'!
foo
	^ 'foo'! !

Object subclass: #MARMockProxyCreator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MareaTests-Swapping'!

!MARMockProxyCreator class methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 12/20/2011 12:51'!
createProxyFor: anObject
	anObject isBehavior 
		ifTrue: [ ^ MARClassProxyMock newProxyFor: anObject  ].
	^ MARRegularObjectProxyMock newProxyFor: anObject.
	! !

Object subclass: #MARProxyMock
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MareaTests-Swapping'!

MARProxyMock subclass: #MARClassProxyMock
	instanceVariableNames: 'superclass methodDict format proxyID'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MareaTests-Swapping'!

!MARClassProxyMock methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 12/7/2011 10:55'!
initialize
	methodDict := MethodDictionary emptyMethodDictionary.! !

!MARClassProxyMock methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 2/5/2012 12:44'!
mareaGraphID
	^ proxyID bitAnd: 2r11111111111111! !

!MARClassProxyMock methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 2/5/2012 12:22'!
mareaPosition
	^ proxyID >> 14
	! !

!MARClassProxyMock methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 12/7/2011 10:31'!
mareaProxyID
	^ proxyID! !

!MARClassProxyMock methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 2/5/2012 16:01'!
mareaSetPosition: aPosition setGraphID: aGraphID
	(aPosition > 131071) ifTrue: [ MARPositionBiggerThanMax new signal: 'MAREA_ERROR3: The position of the proxy is bigger than the maximum. The graph cannot be swapped'. ].
	(aGraphID > 16383) ifTrue: [ MARGraphIDBiggerThanMax new signal: 'MAREA_ERROR: The graphID of the proxy is bigger than the maximum. The graph cannot be swapped'. ].
	proxyID :=  (aGraphID bitAnd:  131071 ) bitOr: (aPosition << 14).
! !

!MARProxyMock class methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 12/20/2011 12:50'!
newProxyFor: anObject 
	^ self new! !

!MARProxyMock methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 12/14/2011 23:40'!
basicIdentityHash
	"Answer a SmallInteger whose value is related to the receiver's identity.
	This method must not be overridden, except by SmallInteger.
	Primitive. Fails if the receiver is a SmallInteger. Essential.
	See Object documentation whatIsAPrimitive.

	Do not override. Use #identityHash unless you really know what you're doing.'"

	<primitive: 75>
	self primitiveFailed! !

!MARProxyMock methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 12/14/2011 23:40'!
identityHash
	"Answer a SmallInteger whose value is related to the receiver's identity.
	This method must not be overridden, except by SmallInteger.
	
	Do not override."

	^ self basicIdentityHash bitShift: 18! !

!MARProxyMock methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 12/19/2011 09:34'!
largeIdentityHash
	<primitive: 75>
	self primitiveFailed! !

!MARProxyMock methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 12/14/2011 23:40'!
mareaIsProxy
	^ true! !

MARProxyMock subclass: #MARRegularObjectProxyMock
	instanceVariableNames: 'proxyID'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MareaTests-Swapping'!

!MARRegularObjectProxyMock methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 2/5/2012 12:43'!
mareaGraphID
	^ proxyID bitAnd: 2r11111111111111! !

!MARRegularObjectProxyMock methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 2/5/2012 12:22'!
mareaPosition
	^ proxyID >> 14! !

!MARRegularObjectProxyMock methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 9/16/2011 14:38'!
mareaProxyID
	^ proxyID! !

!MARRegularObjectProxyMock methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 2/5/2012 16:01'!
mareaSetPosition: aPosition setGraphID: aGraphID
	(aPosition > 131071) ifTrue: [ MARPositionBiggerThanMax new signal: 'MAREA_ERROR7: The position of the proxy is bigger than the maximum. The graph cannot be swapped'. ].
	(aGraphID > 16383) ifTrue: [ MARGraphIDBiggerThanMax new signal: 'MAREA_ERROR: The graphID of the proxy is bigger than the maximum. The graph cannot be swapped'. ].
	proxyID :=  (aGraphID bitAnd:  131071 ) bitOr: (aPosition << 14).
! !

Object subclass: #MockClassSuperclass
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MareaTests-Mocks'!

MockClassSuperclass subclass: #ClassWith1Var
	instanceVariableNames: 'var1'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MareaTests-Mocks'!

!ClassWith1Var class methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 10/25/2010 22:15'!
fooClass
	^ 'fooClass'! !

!ClassWith1Var class methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 12/12/2011 14:44'!
var1: aVar
	^ self new var1: aVar ! !

!ClassWith1Var methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 11/25/2010 14:45'!
fOO
	^ 'fOO'! !

!ClassWith1Var methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 10/2/2010 19:26'!
foo
	^ 'foo'! !

!ClassWith1Var methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 10/18/2010 16:30'!
foo2
	^ 'foo2'! !

!ClassWith1Var methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 11/26/2010 14:27'!
foo3
	^ 'foo3'! !

!ClassWith1Var methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 10/19/2010 23:07'!
foo: something
	^ 'foo'! !

!ClassWith1Var methodsFor: 'test - category' stamp: 'MarianoMartinezPeck 11/23/2010 11:40'!
fooCategory
	^ 'fooCategory'! !

!ClassWith1Var methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 10/20/2010 11:21'!
fooDNU
	self unExistentMethod! !

!ClassWith1Var methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 4/27/2011 17:54'!
fooLong
	| aaa |
	Object new.
	self foo.
	! !

!ClassWith1Var methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 10/17/2010 19:13'!
fooSomething
	^ 'fooSomething'! !

!ClassWith1Var methodsFor: 'accessing' stamp: 'mariano 2/24/2011 15:27'!
fooWithSuper
	super superFoo. 
	^ 'fooWithSuper'! !

!ClassWith1Var methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 9/29/2010 15:30'!
var1
	^ var1! !

!ClassWith1Var methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 9/29/2010 15:30'!
var1: anObject
	var1 := anObject! !

!MockClassSuperclass methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 10/7/2010 14:58'!
superFoo
	^ 'superFoo'! !

Object subclass: #MockCompiledMethodObject
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MareaTests-Mocks'!

!MockCompiledMethodObject methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 10/11/2010 11:47'!
flushCache! !

!MockCompiledMethodObject methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 10/11/2010 11:48'!
methodClass: aMethodClass! !

!MockCompiledMethodObject methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 10/11/2010 11:39'!
run: aSelector with: anArray in: aReceiver
	"we do something".
	Transcript show: 'run: aSelector with: anArray in: aReceiver'.
	^ 'run'! !

!MockCompiledMethodObject methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 10/11/2010 11:48'!
selector: aSymbol! !
CompactClassMock initialize!
